=== modified file '.bzrignore'
--- .bzrignore	2007-09-02 15:42:18 +0000
+++ .bzrignore	2008-06-28 20:24:16 +0000
@@ -10,3 +10,4 @@
 bzr-gtk.trunk-matkor.e3p
 bzr-gtk.trunk-matkor.e3s
 bzr-gtk.trunk-matkor.e3t
+credits.pickle

=== modified file 'AUTHORS'
--- AUTHORS	2008-04-07 20:34:51 +0000
+++ AUTHORS	2008-07-22 22:40:17 +0000
@@ -1,6 +1,8 @@
 bzr-gtk is a plugin that is based on a collection of earlier plugins for 
-Bazaar. It is currently maintained by Jelmer Vernooij <jelmer@samba.org> and 
-Szilveszter Farkas <Szilveszter.Farkas@gmail.com>.
+Bazaar. It was originally developed by Jelmer Vernooij <jelmer@samba.org> and 
+Szilveszter Farkas <Szilveszter.Farkas@gmail.com> but is now maintained 
+by a team of developers; see https://launchpad.net/~bzr-gtk/+members for 
+a list
 
 bzrk was written by Scott James Remnant <scott@ubuntu.com>. 
 It's vaguely based on a screenshot of gitk (the equivalent tool for git)

=== modified file 'HACKING'
--- HACKING	2007-07-15 15:05:06 +0000
+++ HACKING	2008-07-17 11:51:03 +0000
@@ -8,4 +8,8 @@
 (http://developer.gnome.org/projects/gup/hig/) should be followed where 
 possible.
 
+Several parts of bzr-gtk are currently using glade. However, we are slowly
+trying to move away from glade so please don't add new code that uses glade and
+try to remove the use of glade.
+
 Please update the NEWS file when closing bugs or adding new features.

=== modified file 'NEWS'
--- NEWS	2008-06-06 18:04:45 +0000
+++ NEWS	2008-07-25 19:54:31 +0000
@@ -4,19 +4,95 @@
 
   * Added Refresh menu option with F5 keyboard shortcut (Russ Brown)
 
+  * Show progress bars in bzr viz window (Chad Miller, Jelmer Vernooij)
+
+  * Added menu option for indexing branches if bzr-search is present.
+    (Jelmer Vernooij)
+
+  * Add "Send Merge Directive" button in bzr viz. (Jelmer Vernooij)
+
+  * Remove dummy "Edit->Find" option. (Jelmer Vernooij)
+
+  * Added an optional diff panel to bzr vis.  (Scott Scriven)
+
+  * Made bzr vis remember whether the toolbar is visible.  (Scott Scriven)
+
+  * Made bzr vis remember window and panel sizes.  (Scott Scriven)
+
+  * Sort Olive bookmarks by title (Jasper Groenewegen)
+  
+  * Add controls to wrap long lines in gdiff and diff in visualise. (Jasper Groenewegen, #229789)
+
  BUG FIXES
 
   * Replace _() calls by _i18n() calls. (Vincent Ladeuil, #187283)
   
   * Fixed adding tags. (Javier Derderian, #228709)
 
+  * Fix history mode button. (Jasper Groenewegen, #144962)
+
+  * Fixed handle-patch script. (Jelmer Vernooij)
+
+  * Fix import in olive. (Jelmer Vernooij, #223935)
+
+  * Avoid use of removed smart_add. (Jelmer Vernooij, #244025, #244027)
+
+  * Remove use of upstream removed Repository.revision_parents() 
+    (Jelmer Vernooij)
+
+  * List network drives in Olive. (Kevin Light, #244308)
+
+  * Fix progress bar handling. (Jelmer Vernooij)
+
+  * Fix broken symlink handling. (Jasper Groenewegen)
+
+  * Fix import in Olive rename dialog. (Kevin Light)
+
+  * Removed some redundant screen redrawing in bzr vis.  (Scott Scriven)
+
+  * Fixed overflowing labels in bzr vis.  (Scott Scriven)
+
+  * Fix plugin description in gpreferences. (Jasper Groenewegen, #232191)
+
+  * Remove question for setting default push location. (Jasper Groenewegen, #151818)
+
+  * Automatically change to history mode on selecting a revision from the list. (Jasper Groenewegen, #144963)
+
+  * Check if file is versioned before opening gannotate window from olive. (Jasper Groenewegen, #115358)
+
+ CHANGES
+
+  * Moved notify icon code to separate script. (Jelmer Vernooij)
+
+  * Verify testaments when showing signatures on revisions and
+    re-enable signature display. (Jelmer Vernooij)
+
+  * Show credits for bzr-gtk in the about dialog. (Jelmer Vernooij)
+  
+  * Add gmerge command line option (Jasper Groenewegen, #124760)
+
  INTERNALS
 
   * All i18n calls should now go through _i18n which must be imported from
     bzrlib.plugins.gtk. This addresses the occasional collisions with '_' used
     as an anonymous variable. (Vincent Ladeuil)
 
-
+  * Add test for linegraph code. (Jelmer Vernooij)
+
+  * Remove obsolete tortoisebzr tests. (Jelmer Vernooij)
+
+  * Share revision context menu and main revision menu in bzr viz. (Jelmer Vernooij)
+
+  * Remove glade from merge dialog. (Jasper Groenewegen)
+
+  * Remove glade from olive about, rename, remove, move, mkdir, add dialogs. (Jasper Groenewegen)
+
+  * Remove glade from olive main window (Jasper Groenewegen)
+  
+  * Remove glade from olive info dialog (Jasper Groenewegen)
+
+  * Rewrite Olive mouse button event handling (Kevin Light)
+  
 0.94.0    2008-05-04
 
  CHANGES

=== modified file '__init__.py'
--- __init__.py	2008-06-27 16:53:56 +0000
+++ __init__.py	2008-07-25 15:42:45 +0000
@@ -15,7 +15,6 @@
 """Graphical support for Bazaar using GTK.
 
 This plugin includes:
-commit-notify     Start the graphical notifier of commits.
 gannotate         GTK+ annotate. 
 gbranch           GTK+ branching. 
 gcheckout         GTK+ checkout. 
@@ -23,6 +22,7 @@
 gconflicts        GTK+ conflicts. 
 gdiff             Show differences in working tree in a GTK+ Window. 
 ginit             Initialise a new branch.
+gmerge            GTK+ merge dialog
 gmissing          GTK+ missing revisions dialog. 
 gpreferences      GTK+ preferences dialog. 
 gpush             GTK+ push.
@@ -104,21 +104,24 @@
     bzrlib.ui.ui_factory = GtkUIFactory()
 
 
-def data_path():
-    return os.path.dirname(__file__)
-
-
-def icon_path(*args):
-    basedirs = [os.path.join(data_path()),
+def data_basedirs():
+    return [os.path.dirname(__file__),
              "/usr/share/bzr-gtk", 
              "/usr/local/share/bzr-gtk"]
-    for basedir in basedirs:
-        path = os.path.join(basedir, 'icons', *args)
+
+
+def data_path(*args):
+    for basedir in data_basedirs():
+        path = os.path.join(basedir, *args)
         if os.path.exists(path):
             return path
     return None
 
 
+def icon_path(*args):
+    return data_path(os.path.join('icons', *args))
+
+
 def open_display():
     pygtk = import_pygtk()
     try:
@@ -449,6 +452,29 @@
         dialog.run()
 
 
+class cmd_gmerge(Command):
+    """ GTK+ merge dialog
+    
+    """
+    takes_args = ["merge_from_path?"]
+    def run(self, merge_from_path=None):
+        from bzrlib import workingtree
+        from bzrlib.plugins.gtk.dialog import error_dialog
+        from bzrlib.plugins.gtk.merge import MergeDialog
+        
+        (wt, path) = workingtree.WorkingTree.open_containing('.')
+        old_tree = wt.branch.repository.revision_tree(wt.branch.last_revision())
+        delta = wt.changes_from(old_tree)
+        if len(delta.added) or len(delta.removed) or len(delta.renamed) or len(delta.modified):
+            error_dialog(_i18n('There are local changes in the branch'),
+                         _i18n('Please commit or revert the changes before merging.'))
+        else:
+            parent_branch_path = wt.branch.get_parent()
+            merge = MergeDialog(wt, path, parent_branch_path)
+            response = merge.run()
+            merge.destroy()
+
+
 class cmd_gmissing(Command):
     """ GTK+ missing revisions dialog.
 
@@ -512,6 +538,7 @@
     cmd_gconflicts, 
     cmd_gdiff,
     cmd_ginit,
+    cmd_gmerge,
     cmd_gmissing, 
     cmd_gpreferences, 
     cmd_gpush, 
@@ -525,77 +552,6 @@
     register_command(cmd)
 
 
-class cmd_commit_notify(GTKCommand):
-    """Run the bzr commit notifier.
-
-    This is a background program which will pop up a notification on the users
-    screen when a commit occurs.
-    """
-
-    def run(self):
-        from notify import NotifyPopupMenu
-        gtk = open_display()
-        menu = NotifyPopupMenu()
-        icon = gtk.status_icon_new_from_file(icon_path("bzr-icon-64.png"))
-        icon.connect('popup-menu', menu.display)
-
-        import cgi
-        import dbus
-        import dbus.service
-        import pynotify
-        from bzrlib.bzrdir import BzrDir
-        from bzrlib import errors
-        from bzrlib.osutils import format_date
-        from bzrlib.transport import get_transport
-        if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
-            import dbus.glib
-        BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
-        bus = dbus.SessionBus()
-
-        def catch_branch(revision_id, urls):
-            # TODO: show all the urls, or perhaps choose the 'best'.
-            url = urls[0]
-            try:
-                if isinstance(revision_id, unicode):
-                    revision_id = revision_id.encode('utf8')
-                transport = get_transport(url)
-                a_dir = BzrDir.open_from_transport(transport)
-                branch = a_dir.open_branch()
-                revno = branch.revision_id_to_revno(revision_id)
-                revision = branch.repository.get_revision(revision_id)
-                summary = 'New revision %d in %s' % (revno, url)
-                body  = 'Committer: %s\n' % revision.committer
-                body += 'Date: %s\n' % format_date(revision.timestamp,
-                    revision.timezone)
-                body += '\n'
-                body += revision.message
-                body = cgi.escape(body)
-                nw = pynotify.Notification(summary, body)
-                def start_viz(notification=None, action=None, data=None):
-                    """Start the viz program."""
-                    pp = start_viz_window(branch, revision_id)
-                    pp.show()
-                def start_branch(notification=None, action=None, data=None):
-                    """Start a Branch dialog"""
-                    from bzrlib.plugins.gtk.branch import BranchDialog
-                    bd = BranchDialog(remote_path=url)
-                    bd.run()
-                nw.add_action("inspect", "Inspect", start_viz, None)
-                nw.add_action("branch", "Branch", start_branch, None)
-                nw.set_timeout(5000)
-                nw.show()
-            except Exception, e:
-                print e
-                raise
-        bus.add_signal_receiver(catch_branch,
-                                dbus_interface=BROADCAST_INTERFACE,
-                                signal_name="Revision")
-        pynotify.init("bzr commit-notify")
-        gtk.main()
-
-register_command(cmd_commit_notify)
-
-
 class cmd_gselftest(GTKCommand):
     """Version of selftest that displays a notification at the end"""
 

=== modified file 'about.py'
--- about.py	2008-04-01 09:59:41 +0000
+++ about.py	2008-07-18 20:12:54 +0000
@@ -23,7 +23,30 @@
 import bzrlib
 import gtk
 import os
-from bzrlib.plugins.gtk import icon_path
+from bzrlib.branch import Branch
+from bzrlib.errors import NotBranchError, NoRepositoryPresent
+from bzrlib.trace import mutter
+
+from bzrlib.plugins.gtk import data_path, icon_path
+
+
+def read_license():
+    license_paths = [data_path("COPYING"), "/usr/share/common-licenses/GPL-2"]
+    for license_file in license_paths:
+        if license_file is not None and os.path.exists(license_file):
+            return file(license_file).read()
+    # Fall back to just license name if we can't find the file
+    return "GPLv2 or later"
+
+
+def load_credits():
+    import pickle
+    try:
+        credits = pickle.load(file(data_path("credits.pickle")))
+    except IOError:
+        credits = None
+    return credits
+
 
 class AboutDialog(gtk.AboutDialog):
     def __init__(self):
@@ -31,7 +54,15 @@
         self.set_name("Bazaar GTK")
         self.set_version(bzrlib.plugins.gtk.version_string)
         self.set_website("http://bazaar-vcs.org/BzrGtk")
-        self.set_license("GNU GPL v2 or later")
-        self.set_icon(gtk.gdk.pixbuf_new_from_file(icon_path("bzr-icon-64.png")))
+        self.set_license(read_license())
+        self.set_logo(gtk.gdk.pixbuf_new_from_file(icon_path("bzr-icon-64.png")))
+        credits = load_credits()
+        if credits is not None:
+            (authors, documenters, artists, translators) = credits
+            self.set_authors(authors)
+            self.set_documenters(documenters)
+            self.set_artists(artists)
+            self.set_translator_credits("\n".join(translators))
         self.connect ("response", lambda d, r: d.destroy())
 
+

=== modified file 'branchview/linegraph.py'
--- branchview/linegraph.py	2008-06-29 16:11:12 +0000
+++ branchview/linegraph.py	2008-06-30 12:39:07 +0000
@@ -47,7 +47,7 @@
     def update_root_progress(step_number):
         """IFF our container received a root progress bar, then update it."""
         if root_progress is not None:
-            root_progress.update(current=step_number)
+            root_progress.update(None, current_cnt=step_number)
 
     graph_parents = {}
     ghosts = set()
@@ -75,10 +75,10 @@
     update_root_progress(2)
     progress_bar = ui.ui_factory.nested_progress_bar()
     try:
-        progress_bar.update(msg="Removing ghosts", total=len(ghosts))
+        progress_bar.update(msg="Removing ghosts", total_cnt=len(ghosts))
         for i, ghost in enumerate(ghosts):
             if i % 25 == 0:
-                progress_bar.update(current=i)
+                progress_bar.update(None, current_cnt=i)
             for ghost_child in graph_children[ghost]:
                 graph_parents[ghost_child] = [p for p in graph_parents[ghost_child]
                                               if p not in ghosts]
@@ -118,7 +118,7 @@
     update_root_progress(3)
     progress_bar = ui.ui_factory.nested_progress_bar()
     try:
-        progress_bar.update(msg="Finding nodes", total=len(merge_sorted_revisions))
+        progress_bar.update(msg="Finding nodes", total_cnt=len(merge_sorted_revisions))
         for (rev_index, (sequence_number,
                          revid,
                          merge_depth,
@@ -126,7 +126,7 @@
                          end_of_merge)) in enumerate(merge_sorted_revisions):
 
             if rev_index % 25 == 0:
-                progress_bar.update(current=rev_index)
+                progress_bar.update(None, current_cnt=rev_index)
             if maxnum and rev_index >= maxnum:
                 break
             revid_index[revid] = rev_index
@@ -184,10 +184,10 @@
         update_root_progress(4)
         progress_bar = ui.ui_factory.nested_progress_bar()
         try:
-            progress_bar.update(msg="Organizing edges", total=len(branch_ids))
+            progress_bar.update(msg="Organizing edges", total_cnt=len(branch_ids))
             for i, branch_id in enumerate(branch_ids):
                 if i % 25 == 0:
-                    progress_bar.update(current=i)
+                    progress_bar.update(None, current_cnt=i)
                 branch_line = branch_lines[branch_id]
                 
                 # Find the col_index for the direct parent branch. This will be the
@@ -314,10 +314,10 @@
         update_root_progress(5)
         progress_bar = ui.ui_factory.nested_progress_bar()
         try:
-            progress_bar.update(msg="Pretifying graph", total=len(lines))
+            progress_bar.update(msg="Pretifying graph", total_cnt=len(lines))
             for i, (child_index, parent_index, line_col_indexes) in enumerate(lines):
                 if i % 25 == 0:
-                    progress_bar.update(current=i)
+                    progress_bar.update(None, current_cnt=i)
                 (child_col_index, child_color) = linegraph[child_index][1]
                 (parent_col_index, parent_color) = linegraph[parent_index][1]
                 

=== modified file 'branchview/treeview.py'
--- branchview/treeview.py	2008-06-29 16:11:12 +0000
+++ branchview/treeview.py	2008-07-10 06:23:54 +0000
@@ -16,11 +16,13 @@
 from bzrlib import ui
 
 from bzrlib.plugins.gtk import _i18n
+from bzrlib.plugins.gtk.ui import GtkProgressBar, ProgressPanel
 from linegraph import linegraph, same_branch
 from graphcell import CellRendererGraph
 from treemodel import TreeModel
 from bzrlib.revision import NULL_REVISION
 
+
 class TreeView(gtk.VBox):
 
     __gproperties__ = {
@@ -106,6 +108,10 @@
         """
         gtk.VBox.__init__(self, spacing=0)
 
+        loading_msg_widget = ProgressPanel()
+        ui.ui_factory.set_nested_progress_bar_widget(loading_msg_widget.get_progress_bar)
+        self.pack_start(loading_msg_widget, expand=False, fill=True)
+
         self.scrolled_window = gtk.ScrolledWindow()
         self.scrolled_window.set_policy(gtk.POLICY_AUTOMATIC,
                                         gtk.POLICY_AUTOMATIC)
@@ -269,8 +275,8 @@
                        should be broken.
         """
 
-        loading_progress = ui.ui_factory.nested_progress_bar()
-        loading_progress.update(msg="Loading ancestry graph", total=5)
+        self.progress_bar = ui.ui_factory.nested_progress_bar()
+        self.progress_bar.update(msg="Loading ancestry graph", total_cnt=5)
 
         try:
             if self.compact:
@@ -287,7 +293,7 @@
                                                             broken_line_length,
                                                             show_graph,
                                                             self.mainline_only,
-                                                            loading_progress)
+                                                            self.progress_bar)
 
             self.model = TreeModel(self.branch, linegraphdata)
             self.graph_cell.columns_len = columns_len
@@ -304,11 +310,9 @@
             else:
                 self.set_revision(revision)
 
-            self.emit('revisions-loaded')
-
             return False
         finally:
-            loading_progress.finished()
+            self.progress_bar.finished()
 
     def construct_treeview(self):
         self.treeview = gtk.TreeView()
@@ -321,6 +325,7 @@
         if set_tooltip is not None:
             set_tooltip(treemodel.MESSAGE)
 
+        self._prev_cursor_path = None
         self.treeview.connect("cursor-changed",
                 self._on_selection_changed)
 
@@ -392,18 +397,19 @@
         self.treeview.append_column(self.date_column)
         
         return self.treeview
-
+    
     def _on_selection_changed(self, treeview):
         """callback for when the treeview changes."""
         (path, focus) = treeview.get_cursor()
-        if path is not None:
+        if (path is not None) and (path != self._prev_cursor_path):
+            self._prev_cursor_path = path # avoid emitting twice per click
             self.iter = self.model.get_iter(path)
             self.emit('revision-selected')
 
     def _on_revision_selected(self, widget, event):
-        from bzrlib.plugins.gtk.revisionmenu import RevisionPopupMenu
+        from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
         if event.button == 3:
-            menu = RevisionPopupMenu(self.branch.repository, 
+            menu = RevisionMenu(self.branch.repository, 
                 [self.get_revision().revision_id],
                 self.branch)
             menu.connect('tag-added', lambda w, t, r: self.add_tag(t, r))

=== added file 'bzr-notify'
--- bzr-notify	1970-01-01 00:00:00 +0000
+++ bzr-notify	2008-07-18 20:01:12 +0000
@@ -0,0 +1,72 @@
+#!/usr/bin/env python
+
+"""Run the bzr tray icon.
+
+This is a background program which will pop up a notification on the users
+screen when a commit occurs.
+"""
+
+from bzrlib.plugin import load_plugins
+load_plugins()
+
+from bzrlib.plugins.gtk import open_display, icon_path
+
+from bzrlib.plugins.gtk.notify import NotifyPopupMenu
+gtk = open_display()
+menu = NotifyPopupMenu()
+icon = gtk.status_icon_new_from_file(icon_path("bzr-icon-64.png"))
+icon.connect('popup-menu', menu.display)
+
+import cgi
+import dbus
+import dbus.service
+import pynotify
+from bzrlib.bzrdir import BzrDir
+from bzrlib import errors
+from bzrlib.osutils import format_date
+from bzrlib.transport import get_transport
+if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
+	import dbus.glib
+BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
+bus = dbus.SessionBus()
+
+def catch_branch(revision_id, urls):
+	# TODO: show all the urls, or perhaps choose the 'best'.
+	url = urls[0]
+	try:
+		if isinstance(revision_id, unicode):
+			revision_id = revision_id.encode('utf8')
+		transport = get_transport(url)
+		a_dir = BzrDir.open_from_transport(transport)
+		branch = a_dir.open_branch()
+		revno = branch.revision_id_to_revno(revision_id)
+		revision = branch.repository.get_revision(revision_id)
+		summary = 'New revision %d in %s' % (revno, url)
+		body  = 'Committer: %s\n' % revision.committer
+		body += 'Date: %s\n' % format_date(revision.timestamp,
+			revision.timezone)
+		body += '\n'
+		body += revision.message
+		body = cgi.escape(body)
+		nw = pynotify.Notification(summary, body)
+		def start_viz(notification=None, action=None, data=None):
+			"""Start the viz program."""
+			pp = start_viz_window(branch, revision_id)
+			pp.show()
+		def start_branch(notification=None, action=None, data=None):
+			"""Start a Branch dialog"""
+			from bzrlib.plugins.gtk.branch import BranchDialog
+			bd = BranchDialog(remote_path=url)
+			bd.run()
+		nw.add_action("inspect", "Inspect", start_viz, None)
+		nw.add_action("branch", "Branch", start_branch, None)
+		nw.set_timeout(5000)
+		nw.show()
+	except Exception, e:
+		print e
+		raise
+bus.add_signal_receiver(catch_branch,
+						dbus_interface=BROADCAST_INTERFACE,
+						signal_name="Revision")
+pynotify.init("bzr-notify")
+gtk.main()

=== added file 'create-credits.py'
--- create-credits.py	1970-01-01 00:00:00 +0000
+++ create-credits.py	2008-06-28 20:24:16 +0000
@@ -0,0 +1,26 @@
+#!/usr/bin/python
+# Copyright (C) 2008 Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from bzrlib.branch import Branch
+from bzrlib.plugins.stats import find_credits
+
+import pickle
+
+branch = Branch.open(".")
+credits = find_credits(branch.repository, branch.last_revision())
+
+pickle.dump(credits, file("credits.pickle", 'w'))

=== modified file 'diff.py'
--- diff.py	2008-05-22 02:33:40 +0000
+++ diff.py	2008-07-25 13:32:06 +0000
@@ -73,15 +73,15 @@
             self.buffer.set_language(gsl)
             self.buffer.set_highlight(True)
 
-            sourceview = gtksourceview.SourceView(self.buffer)
+            self.sourceview = gtksourceview.SourceView(self.buffer)
         else:
             self.buffer = gtk.TextBuffer()
-            sourceview = gtk.TextView(self.buffer)
+            self.sourceview = gtk.TextView(self.buffer)
 
-        sourceview.set_editable(False)
-        sourceview.modify_font(pango.FontDescription("Monospace"))
-        self.add(sourceview)
-        sourceview.show()
+        self.sourceview.set_editable(False)
+        self.sourceview.modify_font(pango.FontDescription("Monospace"))
+        self.add(self.sourceview)
+        self.sourceview.show()
 
     @staticmethod
     def apply_gedit_colors(lang):
@@ -305,7 +305,7 @@
         scrollwin.set_shadow_type(gtk.SHADOW_IN)
         self.pack1(scrollwin)
         scrollwin.show()
-
+        
         self.model = gtk.TreeStore(str, str)
         self.treeview = gtk.TreeView(self.model)
         self.treeview.set_headers_visible(False)
@@ -330,9 +330,10 @@
         # text view
 
     def set_diff_text_sections(self, sections):
-        self.diff_view = DiffFileView()
+        if getattr(self, 'diff_view', None) is None:
+            self.diff_view = DiffFileView()
+            self.pack2(self.diff_view)
         self.diff_view.show()
-        self.pack2(self.diff_view)
         for oldname, newname, patch in sections:
             self.diff_view._diffs[newname] = str(patch)
             if newname is None:
@@ -346,8 +347,9 @@
         Compares the two trees and populates the window with the
         differences.
         """
-        self.diff_view = DiffView()
-        self.pack2(self.diff_view)
+        if getattr(self, 'diff_view', None) is None:
+            self.diff_view = DiffView()
+            self.pack2(self.diff_view)
         self.diff_view.show()
         self.diff_view.set_trees(rev_tree, parent_tree)
         self.rev_tree = rev_tree
@@ -380,6 +382,7 @@
                 self.model.append(titer, [ path, path ])
 
         self.treeview.expand_all()
+        self.diff_view.show_diff(None)
 
     def set_file(self, file_path):
         """Select the current file to display"""
@@ -402,9 +405,15 @@
             return
         elif specific_files == [ "" ]:
             specific_files = None
-
+        
         self.diff_view.show_diff(specific_files)
-
+    
+    def _on_wraplines_toggled(self, widget=None, wrap=False):
+        """Callback for when the wrap lines checkbutton is toggled"""
+        if wrap or widget.get_active():
+            self.diff_view.sourceview.set_wrap_mode(gtk.WRAP_WORD)
+        else:
+            self.diff_view.sourceview.set_wrap_mode(gtk.WRAP_NONE)
 
 class DiffWindow(Window):
     """Diff window.
@@ -431,13 +440,33 @@
         self.vbox = gtk.VBox()
         self.add(self.vbox)
         self.vbox.show()
+        self.diff = DiffWidget()
+        self.vbox.pack_end(self.diff, True, True, 0)
+        self.diff.show_all()
+        # Build after DiffWidget to connect signals
+        menubar = self._get_menu_bar()
+        self.vbox.pack_start(menubar, False, False, 0)
         hbox = self._get_button_bar(operations)
         if hbox is not None:
-            self.vbox.pack_start(hbox, expand=False, fill=True)
-        self.diff = DiffWidget()
-        self.vbox.add(self.diff)
-        self.diff.show_all()
-
+            self.vbox.pack_start(hbox, False, True, 0)
+        
+    
+    def _get_menu_bar(self):
+        menubar = gtk.MenuBar()
+        # View menu
+        mb_view = gtk.MenuItem(_i18n("_View"))
+        mb_view_menu = gtk.Menu()
+        mb_view_wrapsource = gtk.CheckMenuItem(_i18n("Wrap _Long Lines"))
+        mb_view_wrapsource.connect('activate', self.diff._on_wraplines_toggled)
+        mb_view_wrapsource.show()
+        mb_view_menu.append(mb_view_wrapsource)
+        mb_view.show()
+        mb_view.set_submenu(mb_view_menu)
+        mb_view.show()
+        menubar.append(mb_view)
+        menubar.show()
+        return menubar
+    
     def _get_button_bar(self, operations):
         """Return a button bar to use.
 

=== modified file 'merge.py'
--- merge.py	2008-05-05 18:16:46 +0000
+++ merge.py	2008-07-25 15:42:45 +0000
@@ -23,48 +23,66 @@
     pass
 
 import gtk
-import gtk.glade
 
 from bzrlib.branch import Branch
 import bzrlib.errors as errors
+
 from bzrlib.plugins.gtk import _i18n
-
-from dialog import error_dialog, info_dialog, warning_dialog
-from errors import show_bzr_error
-from olive.guifiles import GLADEFILENAME
-
-
-class MergeDialog:
+from bzrlib.plugins.gtk.dialog import error_dialog, info_dialog, warning_dialog
+from bzrlib.plugins.gtk.errors import show_bzr_error
+
+
+class MergeDialog(gtk.Dialog):
     """ Display the Merge dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath,default_branch_path=None):
+    
+    def __init__(self, wt, wtpath, default_branch_path=None, parent=None):
         """ Initialize the Merge dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_merge', 'olive-gtk')
-        
-        self.window = self.glade.get_widget('window_merge')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_merge_merge_clicked": self.merge,
-                "on_button_merge_cancel_clicked": self.close,
-                "on_button_merge_open_clicked": self.open }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-
+        gtk.Dialog.__init__(self, title="Olive - Merge",
+                                  parent=parent,
+                                  flags=0,
+                                  buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+        
+        # Get arguments
         self.wt = wt
         self.wtpath = wtpath
         
-        # Get some widgets
-        self.entry = self.glade.get_widget('entry_merge')
-        if default_branch_path:
-            self.entry.set_text(default_branch_path)
-
-    def display(self):
-        """ Display the Add file(s) dialog. """
-        self.window.show_all()
+        if default_branch_path and os.path.isdir(default_branch_path.partition('file://')[2]):
+            directory = default_branch_path.partition('file://')[2]
+        else:
+            directory = os.path.dirname(self.wt.abspath(self.wtpath))
+        
+        # Create widgets
+        self._hbox = gtk.HBox()
+        self._label_merge_from = gtk.Label(_i18n("Merge from"))
+        self._filechooser_dialog = gtk.FileChooserDialog(title="Please select a folder",
+                                    parent=self.window,
+                                    action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
+                                    buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
+                                             gtk.STOCK_OPEN, gtk.RESPONSE_OK))
+        self._filechooser_dialog.set_default_response(gtk.RESPONSE_OK)
+        self._filechooser = gtk.FileChooserButton(self._filechooser_dialog)
+        self._button_merge = gtk.Button(_i18n("_Merge"))
+        self._button_merge_icon = gtk.Image()
+        self._button_merge_icon.set_from_stock(gtk.STOCK_APPLY, gtk.ICON_SIZE_BUTTON)
+        self._button_merge.set_image(self._button_merge_icon)
+        
+        self._button_merge.connect('clicked', self._on_merge_clicked)
+        
+        # Set location
+        self._filechooser_dialog.set_current_folder(directory)
+        
+        # Add widgets to dialog
+        self.vbox.add(self._hbox)
+        self._hbox.add(self._label_merge_from)
+        self._hbox.add(self._filechooser)
+        self._hbox.set_spacing(5)
+        self.action_area.pack_end(self._button_merge)
+        
+        self.vbox.show_all()
 
     @show_bzr_error
-    def merge(self, widget):
-        branch = self.entry.get_text()
+    def _on_merge_clicked(self, widget):
+        branch = self._filechooser.get_filename()
         if branch == "":
             error_dialog(_i18n('Branch not given'),
                          _i18n('Please specify a branch to merge from.'))
@@ -78,7 +96,6 @@
             error_dialog(_i18n('Bazaar command error'), str(errmsg))
             return
         
-        self.close()
         if conflicts == 0:
             # No conflicts found.
             info_dialog(_i18n('Merge successful'),
@@ -87,19 +104,5 @@
             # There are conflicts to be resolved.
             warning_dialog(_i18n('Conflicts encountered'),
                            _i18n('Please resolve the conflicts manually before committing.'))
-    
-    def open(self, widget):
-        fcd = gtk.FileChooserDialog(title="Please select a folder",
-                                    parent=self.window,
-                                    action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
-                                    buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
-                                             gtk.STOCK_OPEN, gtk.RESPONSE_OK))
-        fcd.set_default_response(gtk.RESPONSE_OK)
-        
-        if fcd.run() == gtk.RESPONSE_OK:
-            self.entry.set_text(fcd.get_filename())
-        
-        fcd.destroy()
-        
-    def close(self, widget=None):
-        self.window.destroy()
+        
+        self.response(gtk.RESPONSE_OK)

=== modified file 'notify.py'
--- notify.py	2007-07-15 15:13:34 +0000
+++ notify.py	2008-07-18 20:19:45 +0000
@@ -74,12 +74,12 @@
             self.zeroconfserver.close()
 
     def show_about(self, item):
-        from about import AboutDialog
+        from bzrlib.plugins.gtk.about import AboutDialog
         dialog = AboutDialog()
         dialog.run()
 
     def show_preferences(self, item):
-        from preferences import PreferencesWindow
+        from bzrlib.plugins.gtk.preferences import PreferencesWindow
         prefs = PreferencesWindow()
         prefs.run()
 

=== removed file 'olive.glade'
--- olive.glade	2008-03-30 14:12:10 +0000
+++ olive.glade	1970-01-01 00:00:00 +0000
@@ -1,2550 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE glade-interface SYSTEM "glade-2.0.dtd">
-<!--*- mode: xml -*-->
-<glade-interface>
-  <widget class="GtkWindow" id="window_main">
-    <property name="width_request">700</property>
-    <property name="height_request">400</property>
-    <property name="title" translatable="yes">Olive - Bazaar GUI</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <signal name="destroy" handler="on_window_main_destroy"/>
-    <signal name="delete_event" handler="on_window_main_delete_event"/>
-    <child>
-      <widget class="GtkVBox" id="vbox_main">
-        <property name="visible">True</property>
-        <child>
-          <widget class="GtkMenuBar" id="menubar">
-            <property name="visible">True</property>
-            <child>
-              <widget class="GtkMenuItem" id="menuitem_file">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">_File</property>
-                <property name="use_underline">True</property>
-                <child>
-                  <widget class="GtkMenu" id="menuitem_file_menu">
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_add_files">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Add file(s)...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_add_files_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image241">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-add</property>
-                            <property name="icon_size">1</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_remove_file">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Remove file(s)...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_remove_file_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image242">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-remove</property>
-                            <property name="icon_size">1</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_file3">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_file_bookmark">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Bookmark current directory</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_file_bookmark_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_file_make_directory">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Make _directory...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_file_make_directory_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_file1">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_file_rename">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Rename...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_file_rename_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_file_move">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Move...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_file_move_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_file_annotate">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Annotate...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_file_annotate_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_file2">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_quit">
-                        <property name="visible">True</property>
-                        <property name="label">gtk-quit</property>
-                        <property name="use_underline">True</property>
-                        <property name="use_stock">True</property>
-                        <signal name="activate" handler="on_quit_activate"/>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkMenuItem" id="menuitem_view">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">_View</property>
-                <property name="use_underline">True</property>
-                <signal name="activate" handler="on_menuitem_view_activate"/>
-                <child>
-                  <widget class="GtkMenu" id="menuitem_view_menu">
-                    <child>
-                      <widget class="GtkCheckMenuItem" id="menuitem_view_show_hidden_files">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Show _hidden files</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_view_show_hidden_files_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkCheckMenuItem" id="menuitem_view_show_ignored_files">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Show _ignored files</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_view_show_ignored_files_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_view1">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_view_refresh">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Refresh</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_view_refresh_activate"/>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkMenuItem" id="menuitem_branch">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">_Branch</property>
-                <property name="use_underline">True</property>
-                <child>
-                  <widget class="GtkMenu" id="menuitem_branch_menu">
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_initialize">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Initialize...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_initialize_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_get">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Get...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_get_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_checkout">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">C_heckout...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_checkout_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_branch1">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_branch_pull">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Pu_ll</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_pull_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image243">
-                            <property name="visible">True</property>
-                            <property name="pixbuf">icons/pull16.png</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_branch_push">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Pu_sh...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_push_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image244">
-                            <property name="visible">True</property>
-                            <property name="pixbuf">icons/push16.png</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_update">
-                        <property name="visible">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="label" translatable="yes">Update</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_update_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_branch2">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_revert">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Revert all changes</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_revert_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_merge">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Merge...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_merge_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_branch_commit">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Commit...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_commit_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image245">
-                            <property name="visible">True</property>
-                            <property name="pixbuf">icons/commit16.png</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_branch3">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_tags">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Ta_gs...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_tags_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_status">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">S_tatus...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_status_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_missing_revisions">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Missing _revisions</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_missing_revisions_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_conflicts">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Con_flicts...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_conflicts_activate"/>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkMenuItem" id="menuitem_stats">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">_Statistics</property>
-                <property name="use_underline">True</property>
-                <child>
-                  <widget class="GtkMenu" id="menuitem_stats_menu">
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_stats_diff">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Differences...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_stats_diff_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image246">
-                            <property name="visible">True</property>
-                            <property name="pixbuf">icons/diff16.png</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_stats_log">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Log...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_stats_log_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image247">
-                            <property name="visible">True</property>
-                            <property name="pixbuf">icons/log16.png</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_stats_infos">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Information...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_stats_infos_activate"/>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkMenuItem" id="menuitem_help">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">_Help</property>
-                <property name="use_underline">True</property>
-                <child>
-                  <widget class="GtkMenu" id="menuitem_help_menu">
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_about">
-                        <property name="visible">True</property>
-                        <property name="label">gtk-about</property>
-                        <property name="use_underline">True</property>
-                        <property name="use_stock">True</property>
-                        <signal name="activate" handler="on_about_activate"/>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkToolbar" id="toolbar">
-            <property name="visible">True</property>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_refresh">
-                <property name="visible">True</property>
-                <property name="label">Refresh</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/refresh.png</property>
-                <signal name="clicked" handler="on_toolbutton_refresh_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_diff">
-                <property name="visible">True</property>
-                <property name="label">Diff</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/diff.png</property>
-                <signal name="clicked" handler="on_toolbutton_diff_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_log">
-                <property name="visible">True</property>
-                <property name="label">Log</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/log.png</property>
-                <signal name="clicked" handler="on_toolbutton_log_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkSeparatorToolItem" id="separatortoolitem1">
-                <property name="visible">True</property>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="homogeneous">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_commit">
-                <property name="visible">True</property>
-                <property name="is_important">True</property>
-                <property name="label">Commit</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/commit.png</property>
-                <signal name="clicked" handler="on_toolbutton_commit_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkSeparatorToolItem" id="separatortoolitem2">
-                <property name="visible">True</property>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="homogeneous">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_pull">
-                <property name="visible">True</property>
-                <property name="is_important">True</property>
-                <property name="label">Pull</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/pull.png</property>
-                <signal name="clicked" handler="on_toolbutton_pull_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_push">
-                <property name="visible">True</property>
-                <property name="is_important">True</property>
-                <property name="label">Push</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/push.png</property>
-                <signal name="clicked" handler="on_toolbutton_push_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_update">
-                <property name="visible">True</property>
-                <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                <property name="label" translatable="yes">Update</property>
-                <property name="icon">icons/pull.png</property>
-                <signal name="clicked" handler="on_toolbutton_update_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">1</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkHPaned" id="hpaned_main">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="position">200</property>
-            <child>
-              <widget class="GtkScrolledWindow" id="scrolledwindow_left">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="hscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-                <property name="vscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-                <child>
-                  <widget class="GtkTreeView" id="treeview_left">
-                    <property name="visible">True</property>
-                    <property name="can_focus">True</property>
-                    <property name="headers_visible">False</property>
-                    <signal name="button_press_event" handler="on_treeview_left_button_press_event"/>
-                    <signal name="button_release_event" handler="on_treeview_left_button_release_event"/>
-                    <signal name="row_activated" handler="on_treeview_left_row_activated"/>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="resize">False</property>
-                <property name="shrink">True</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkVBox" id="vbox_main_right">
-                <property name="visible">True</property>
-                <child>
-                  <widget class="GtkHBox" id="hbox_location">
-                    <property name="visible">True</property>
-                    <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                    <property name="border_width">3</property>
-                    <property name="spacing">3</property>
-                    <child>
-                      <widget class="GtkButton" id="button_location_up">
-                        <property name="visible">True</property>
-                        <property name="can_focus">True</property>
-                        <property name="receives_default">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="relief">GTK_RELIEF_NONE</property>
-                        <property name="response_id">0</property>
-                        <signal name="clicked" handler="on_button_location_up_clicked"/>
-                        <child>
-                          <widget class="GtkImage" id="image_location_up">
-                            <property name="visible">True</property>
-                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                            <property name="stock">gtk-go-up</property>
-                          </widget>
-                        </child>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <placeholder/>
-                    </child>
-                    <child>
-                      <widget class="GtkEntry" id="entry_location">
-                        <property name="visible">True</property>
-                        <property name="can_focus">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <signal name="key_press_event" handler="on_entry_location_key_press_event"/>
-                      </widget>
-                      <packing>
-                        <property name="position">2</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkImage" id="image_location_error">
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="stock">gtk-dialog-error</property>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">3</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkButton" id="button_location_jump">
-                        <property name="visible">True</property>
-                        <property name="can_focus">True</property>
-                        <property name="receives_default">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="label" translatable="yes">gtk-jump-to</property>
-                        <property name="relief">GTK_RELIEF_NONE</property>
-                        <property name="use_stock">True</property>
-                        <property name="response_id">0</property>
-                        <signal name="clicked" handler="on_button_location_jump_clicked"/>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">4</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkVSeparator" id="vseparator">
-                        <property name="visible">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">5</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkCheckButton" id="checkbutton_history">
-                        <property name="visible">True</property>
-                        <property name="can_focus">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="label" translatable="yes">H_istory Mode</property>
-                        <property name="use_underline">True</property>
-                        <property name="response_id">0</property>
-                        <property name="draw_indicator">True</property>
-                        <signal name="toggled" handler="on_checkbutton_history_toggled"/>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">6</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkEntry" id="entry_history_revno">
-                        <property name="width_request">75</property>
-                        <property name="visible">True</property>
-                        <property name="sensitive">False</property>
-                        <property name="can_focus">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <signal name="key_press_event" handler="on_entry_history_revno_key_press_event"/>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">7</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkButton" id="button_history_browse">
-                        <property name="visible">True</property>
-                        <property name="sensitive">False</property>
-                        <property name="can_focus">True</property>
-                        <property name="receives_default">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="response_id">0</property>
-                        <signal name="clicked" handler="on_button_history_browse_clicked"/>
-                        <child>
-                          <widget class="GtkImage" id="image_history_browse">
-                            <property name="visible">True</property>
-                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                            <property name="stock">gtk-open</property>
-                          </widget>
-                        </child>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">8</property>
-                      </packing>
-                    </child>
-                  </widget>
-                  <packing>
-                    <property name="expand">False</property>
-                    <property name="fill">False</property>
-                  </packing>
-                </child>
-                <child>
-                  <widget class="GtkScrolledWindow" id="scrolledwindow_right">
-                    <property name="visible">True</property>
-                    <property name="can_focus">True</property>
-                    <property name="hscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-                    <property name="vscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-                    <child>
-                      <widget class="GtkTreeView" id="treeview_right">
-                        <property name="visible">True</property>
-                        <property name="can_focus">True</property>
-                        <property name="headers_visible">False</property>
-                        <signal name="button_press_event" handler="on_treeview_right_button_press_event"/>
-                        <signal name="row_activated" handler="on_treeview_right_row_activated"/>
-                      </widget>
-                    </child>
-                  </widget>
-                  <packing>
-                    <property name="position">1</property>
-                  </packing>
-                </child>
-              </widget>
-              <packing>
-                <property name="resize">True</property>
-                <property name="shrink">True</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkStatusbar" id="statusbar">
-            <property name="visible">True</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">3</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkAboutDialog" id="aboutdialog">
-    <property name="visible">True</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_NORMAL</property>
-    <property name="name">Olive</property>
-    <property name="copyright" translatable="yes">Copyright (C) 2006 Szilveszter Farkas (Phanatic)</property>
-    <property name="website">https://launchpad.net/products/olive</property>
-    <property name="website_label" translatable="yes">https://launchpad.net/products/olive</property>
-    <property name="authors">Szilveszter Farkas (Phanatic) &lt;szilveszter.farkas@gmail.com&gt;</property>
-    <property name="translator_credits" translatable="yes" comments="TRANSLATORS: Replace this string with your names, one name per line.">translator-credits</property>
-    <property name="logo">icons/oliveicon2.png</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="dialog-vbox1">
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="dialog-action_area1">
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_add">
-    <property name="visible">True</property>
-    <property name="title" translatable="yes">Olive - Add file(s)</property>
-    <property name="resizable">False</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_add">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkLabel" id="label_add_question">
-            <property name="visible">True</property>
-            <property name="label" translatable="yes">Which file(s) do you want to add?</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkRadioButton" id="radiobutton_add_selected">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="label" translatable="yes">Selected only</property>
-            <property name="use_underline">True</property>
-            <property name="response_id">0</property>
-            <property name="draw_indicator">True</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">3</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkRadioButton" id="radiobutton_add_unknown">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="label" translatable="yes">All unknowns recursively</property>
-            <property name="use_underline">True</property>
-            <property name="response_id">0</property>
-            <property name="draw_indicator">True</property>
-            <property name="group">radiobutton_add_selected</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">4</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_add">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_add_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_add_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_add_add">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_add_add_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment3">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox5">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image13">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-add</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label8">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Add</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_remove">
-    <property name="visible">True</property>
-    <property name="title" translatable="yes">Olive - Remove file(s)</property>
-    <property name="resizable">False</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_remove">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkLabel" id="label_remove_question">
-            <property name="visible">True</property>
-            <property name="label" translatable="yes">Which file(s) do you want to remove?</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkRadioButton" id="radiobutton_remove_selected">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="label" translatable="yes">Selected only</property>
-            <property name="use_underline">True</property>
-            <property name="response_id">0</property>
-            <property name="draw_indicator">True</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">3</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkRadioButton" id="radiobutton_remove_new">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="label" translatable="yes">All files with status 'added'</property>
-            <property name="use_underline">True</property>
-            <property name="response_id">0</property>
-            <property name="draw_indicator">True</property>
-            <property name="group">radiobutton_remove_selected</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">4</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_remove">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_remove_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_remove_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_remove_remove">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_remove_remove_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment4">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox6">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image39">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-remove</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label10">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Remove</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_mkdir">
-    <property name="visible">True</property>
-    <property name="title" translatable="yes">Olive - Make directory</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_mkdir">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkEntry" id="entry_mkdir">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="has_focus">True</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkCheckButton" id="checkbutton_mkdir_versioned">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="label" translatable="yes">_Versioned directory</property>
-            <property name="use_underline">True</property>
-            <property name="response_id">0</property>
-            <property name="active">True</property>
-            <property name="draw_indicator">True</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">3</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_mkdir">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_mkdir_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_mkdir_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_mkdir_mkdir">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_mkdir_mkdir_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment8">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox10">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image143">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-add</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label17">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Make directory</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_move">
-    <property name="width_request">250</property>
-    <property name="title" translatable="yes">Olive - Move</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_move">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkHBox" id="hbox_move">
-            <property name="visible">True</property>
-            <property name="spacing">5</property>
-            <child>
-              <widget class="GtkLabel" id="label_move">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">Move to</property>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="fill">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkFileChooserButton" id="filechooserbutton_move">
-                <property name="visible">True</property>
-                <property name="action">GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER</property>
-                <property name="title" translatable="yes">Select a directory</property>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_move">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_move_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_move_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_move_move">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_move_move_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment9">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox11">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image151">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-apply</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label18">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Move</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_rename">
-    <property name="title" translatable="yes">Olive - Rename</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_rename">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkHBox" id="hbox_rename">
-            <property name="visible">True</property>
-            <property name="spacing">5</property>
-            <child>
-              <widget class="GtkLabel" id="label_rename">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">Rename to</property>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="fill">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkEntry" id="entry_rename">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="has_focus">True</property>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_rename">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_rename_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_rename_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_rename_rename">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_rename_rename_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment10">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox13">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image159">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-apply</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label20">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Rename</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_info">
-    <property name="title" translatable="yes">Olive - Information</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_NORMAL</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_info">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkExpander" id="expander_info_location">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_location_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment11">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_location">
-                    <property name="visible">True</property>
-                    <property name="n_rows">7</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repobranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_cobranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repoco">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_coroot">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_branchroot">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_sharedrepo">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_lightcoroot">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_coroot_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Checkout root: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_branchroot_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Branch root: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repoco_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository checkout: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_cobranch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Checkout of branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repobranch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_sharedrepo_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Shared repository: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_lightcoroot_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Light checkout root: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_location">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Location:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_related">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_related_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment12">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_related">
-                    <property name="visible">True</property>
-                    <property name="n_rows">2</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_related_parentbranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_related_publishbranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_related_publishbranch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Publish to branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_related_parentbranch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Parent branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_related">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Related branches:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">3</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_format">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_format_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment13">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_format">
-                    <property name="visible">True</property>
-                    <property name="n_rows">4</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_control">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_workingtree">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_branch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_repository">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_repository_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository format: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_branch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Branch format: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_workingtree_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Working tree format: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_control_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Control format: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_format">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Format:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">4</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_locking">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_locking_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment14">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_locking">
-                    <property name="visible">True</property>
-                    <property name="n_rows">3</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_workingtree">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_branch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_repository">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_repository_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository lock status: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_branch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Branch lock status: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_workingtree_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Working tree lock status: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_locking">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Lock status:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">5</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_missing">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_missing_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment15">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_missing">
-                    <property name="visible">True</property>
-                    <property name="n_rows">2</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_missing_workingtree">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_missing_branch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_missing_branch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Missing revisions in branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_missing_workingtree_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Missing revisions in working tree: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_missing">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Missing revisions:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">6</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_wtstats">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_wtstats_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment16">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_wtstats">
-                    <property name="visible">True</property>
-                    <property name="n_rows">8</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_unchanged">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_modified">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_added">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_removed">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_renamed">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_unknown">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_ignored">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_subdirs">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">7</property>
-                        <property name="bottom_attach">8</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_subdirs_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Versioned subdirectories: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">7</property>
-                        <property name="bottom_attach">8</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_ignored_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Ignored files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_unknown_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Unknown files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_renamed_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Renamed files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_removed_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Removed files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_added_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Added files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_modified_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Modified files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_unchanged_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Unchanged files: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_wtstats">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;In the working tree:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">7</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_brstats">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_brstats_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment17">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_brstats">
-                    <property name="visible">True</property>
-                    <property name="n_rows">5</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_revno">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_commiters">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_age">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_firstrev">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_lastrev">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_lastrev_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Time of last revision: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_firstrev_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Time of first revision: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_age_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Age of branch in days: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_commiters_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Number of commiters: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_revno_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Revisions in branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_brstats">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Branch history:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">8</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_repstats">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_repstats_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment18">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_repstats">
-                    <property name="visible">True</property>
-                    <property name="n_rows">2</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_repstats_revisions">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_repstats_size">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_repstats_size_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Size of repository: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_repstats_revisions_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Revisions in repository: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_repstats">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Revision store:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">9</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_info">
-            <property name="visible">True</property>
-            <property name="can_default">True</property>
-            <property name="has_default">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_info_close">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="label">gtk-close</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_info_close_clicked"/>
-              </widget>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_merge">
-    <property name="visible">True</property>
-    <property name="title" translatable="yes">Merge - Olive</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_merge">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkHBox" id="hbox_merge">
-            <property name="visible">True</property>
-            <property name="spacing">3</property>
-            <child>
-              <widget class="GtkLabel" id="label_merge">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">Merge from:</property>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="fill">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkEntry" id="entry_merge">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_merge_open">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_merge_open_clicked"/>
-                <child>
-                  <widget class="GtkImage" id="image240">
-                    <property name="visible">True</property>
-                    <property name="stock">gtk-open</property>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="fill">False</property>
-                <property name="position">2</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_merge">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_merge_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_merge_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_merge_merge">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_merge_merge_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment19">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox14">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image239">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-apply</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label21">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Merge</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-</glade-interface>

=== removed file 'olive.gladep'
--- olive.gladep	2007-08-10 10:45:06 +0000
+++ olive.gladep	1970-01-01 00:00:00 +0000
@@ -1,8 +0,0 @@
-<?xml version="1.0" standalone="no"?> <!--*- mode: xml -*-->
-<!DOCTYPE glade-project SYSTEM "http://glade.gnome.org/glade-project-2.0.dtd">
-
-<glade-project>
-  <name>olive</name>
-  <program_name>olive</program_name>
-  <pixmaps_directory>.</pixmaps_directory>
-</glade-project>

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2008-06-23 08:05:19 +0000
+++ olive/__init__.py	2008-07-25 19:54:31 +0000
@@ -1,5 +1,3 @@
- #!/usr/bin/python
-
 # Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -19,6 +17,7 @@
 import os
 import sys
 import time
+import errno
 
 # gettext support
 import gettext
@@ -33,7 +32,6 @@
 import gobject
 import gtk
 import gtk.gdk
-import gtk.glade
 
 from bzrlib.branch import Branch
 import bzrlib.errors as bzrerrors
@@ -44,7 +42,7 @@
 from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog, info_dialog, warning_dialog
 from bzrlib.plugins.gtk.errors import show_bzr_error
-from guifiles import GLADEFILENAME
+from bzrlib.plugins.gtk.olive.window import OliveGui
 
 from bzrlib.plugins.gtk.diff import DiffWindow
 lazy_import(globals(), """
@@ -60,15 +58,18 @@
 
 def about():
     """ Display the AboutDialog. """
-    from bzrlib.plugins.gtk import __version__
-    from bzrlib.plugins.gtk.olive.guifiles import GLADEFILENAME
-
-    # Load AboutDialog description
-    dglade = gtk.glade.XML(GLADEFILENAME, 'aboutdialog')
-    dialog = dglade.get_widget('aboutdialog')
-
-    # Set version
+    from bzrlib.plugins.gtk import __version__, icon_path
+    
+    iconpath = icon_path() + os.sep
+    
+    dialog = gtk.AboutDialog()
+    dialog.set_name("Olive")
     dialog.set_version(__version__)
+    dialog.set_copyright("Copyright (C) 2006 Szilveszter Farkas (Phanatic)")
+    dialog.set_website("https://launchpad.net/products/olive")
+    dialog.set_website_label("https://launchpad.net/products/olive")
+    dialog.set_icon_from_file(iconpath+"oliveicon2.png")
+    dialog.set_logo(gtk.gdk.pixbuf_new_from_file(iconpath+"oliveicon2.png"))
     dialog.set_authors([ _i18n("Lead Developer:"),
 			 "Szilveszter Farkas <szilveszter.farkas@gmail.com>",
 			 _i18n("Contributors:"),
@@ -87,129 +88,33 @@
     program. """
     
     def __init__(self):
-        self.toplevel = gtk.glade.XML(GLADEFILENAME, 'window_main', 'olive-gtk')
-        self.window = self.toplevel.get_widget('window_main')
+        self.window = OliveGui(calling_app = self)
+        
         self.pref = Preferences()
         self.path = None
 
         # Initialize the statusbar
-        self.statusbar = self.toplevel.get_widget('statusbar')
-        self.context_id = self.statusbar.get_context_id('olive')
-        
-        # Get the main window
-        self.window_main = self.toplevel.get_widget('window_main')
-        # Get the HPaned
-        self.hpaned_main = self.toplevel.get_widget('hpaned_main')
-        # Get the TreeViews
-        self.treeview_left = self.toplevel.get_widget('treeview_left')
-        self.treeview_right = self.toplevel.get_widget('treeview_right')
-        # Get some important menu items
-        self.menuitem_add_files = self.toplevel.get_widget('menuitem_add_files')
-        self.menuitem_remove_files = self.toplevel.get_widget('menuitem_remove_file')
-        self.menuitem_file_bookmark = self.toplevel.get_widget('menuitem_file_bookmark')
-        self.menuitem_file_make_directory = self.toplevel.get_widget('menuitem_file_make_directory')
-        self.menuitem_file_rename = self.toplevel.get_widget('menuitem_file_rename')
-        self.menuitem_file_move = self.toplevel.get_widget('menuitem_file_move')
-        self.menuitem_file_annotate = self.toplevel.get_widget('menuitem_file_annotate')
-        self.menuitem_view_show_hidden_files = self.toplevel.get_widget('menuitem_view_show_hidden_files')
-        self.menuitem_view_show_ignored_files = self.toplevel.get_widget('menuitem_view_show_ignored_files')
-        self.menuitem_branch = self.toplevel.get_widget('menuitem_branch')
-        self.menuitem_branch_init = self.toplevel.get_widget('menuitem_branch_initialize')
-        self.menuitem_branch_get = self.toplevel.get_widget('menuitem_branch_get')
-        self.menuitem_branch_checkout = self.toplevel.get_widget('menuitem_branch_checkout')
-        self.menuitem_branch_pull = self.toplevel.get_widget('menuitem_branch_pull')
-        self.menuitem_branch_push = self.toplevel.get_widget('menuitem_branch_push')
-        self.menuitem_branch_update = self.toplevel.get_widget('menuitem_branch_update')
-        self.menuitem_branch_revert = self.toplevel.get_widget('menuitem_branch_revert')
-        self.menuitem_branch_merge = self.toplevel.get_widget('menuitem_branch_merge')
-        self.menuitem_branch_commit = self.toplevel.get_widget('menuitem_branch_commit')
-        self.menuitem_branch_tags = self.toplevel.get_widget('menuitem_branch_tags')
-        self.menuitem_branch_status = self.toplevel.get_widget('menuitem_branch_status')
-        self.menuitem_branch_missing = self.toplevel.get_widget('menuitem_branch_missing_revisions')
-        self.menuitem_branch_conflicts = self.toplevel.get_widget('menuitem_branch_conflicts')
-        self.menuitem_stats = self.toplevel.get_widget('menuitem_stats')
-        self.menuitem_stats_diff = self.toplevel.get_widget('menuitem_stats_diff')
-        self.menuitem_stats_log = self.toplevel.get_widget('menuitem_stats_log')
-        # Get some toolbuttons
-        #self.menutoolbutton_diff = self.toplevel.get_widget('menutoolbutton_diff')
-        self.toolbutton_diff = self.toplevel.get_widget('toolbutton_diff')
-        self.toolbutton_log = self.toplevel.get_widget('toolbutton_log')
-        self.toolbutton_commit = self.toplevel.get_widget('toolbutton_commit')
-        self.toolbutton_pull = self.toplevel.get_widget('toolbutton_pull')
-        self.toolbutton_push = self.toplevel.get_widget('toolbutton_push')
-        self.toolbutton_update = self.toplevel.get_widget('toolbutton_update')
+        self.context_id = self.window.statusbar.get_context_id('olive')
+        
+		# Get the TreeViews
+        self.treeview_left = self.window.treeview_left
+        self.treeview_right = self.window.treeview_right
+        
         # Get the drive selector
         self.combobox_drive = gtk.combo_box_new_text()
         self.combobox_drive.connect("changed", self._refresh_drives)
         
         # Get the navigation widgets
-        self.hbox_location = self.toplevel.get_widget('hbox_location')
-        self.button_location_up = self.toplevel.get_widget('button_location_up')
-        self.button_location_jump = self.toplevel.get_widget('button_location_jump')
-        self.entry_location = self.toplevel.get_widget('entry_location')
-        self.image_location_error = self.toplevel.get_widget('image_location_error')
+        self.hbox_location = self.window.locationbar
+        self.button_location_up = self.window.button_location_up
+        self.button_location_jump = self.window.button_location_jump
+        self.entry_location = self.window.entry_location
+        self.image_location_error = self.window.image_location_error
         
         # Get the History widgets
-        self.check_history = self.toplevel.get_widget('checkbutton_history')
-        self.entry_history = self.toplevel.get_widget('entry_history_revno')
-        self.button_history = self.toplevel.get_widget('button_history_browse')
-        
-        self.vbox_main_right = self.toplevel.get_widget('vbox_main_right')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_window_main_destroy": gtk.main_quit,
-                "on_window_main_delete_event": self.on_window_main_delete_event,
-                "on_quit_activate": self.on_window_main_delete_event,
-                "on_about_activate": self.on_about_activate,
-                "on_menuitem_add_files_activate": self.on_menuitem_add_files_activate,
-                "on_menuitem_remove_file_activate": self.on_menuitem_remove_file_activate,
-                "on_menuitem_file_bookmark_activate": self.on_menuitem_file_bookmark_activate,
-                "on_menuitem_file_make_directory_activate": self.on_menuitem_file_make_directory_activate,
-                "on_menuitem_file_move_activate": self.on_menuitem_file_move_activate,
-                "on_menuitem_file_rename_activate": self.on_menuitem_file_rename_activate,
-                "on_menuitem_file_annotate_activate": self.on_menuitem_file_annotate_activate,
-                "on_menuitem_view_show_hidden_files_activate": self.on_menuitem_view_show_hidden_files_activate,
-                "on_menuitem_view_show_ignored_files_activate": self.on_menuitem_view_show_ignored_files_activate,
-                "on_menuitem_view_refresh_activate": self.on_menuitem_view_refresh_activate,
-                "on_menuitem_branch_initialize_activate": self.on_menuitem_branch_initialize_activate,
-                "on_menuitem_branch_get_activate": self.on_menuitem_branch_get_activate,
-                "on_menuitem_branch_checkout_activate": self.on_menuitem_branch_checkout_activate,
-                "on_menuitem_branch_revert_activate": self.on_menuitem_branch_revert_activate,
-                "on_menuitem_branch_merge_activate": self.on_menuitem_branch_merge_activate,
-                "on_menuitem_branch_commit_activate": self.on_menuitem_branch_commit_activate,
-                "on_menuitem_branch_push_activate": self.on_menuitem_branch_push_activate,
-                "on_menuitem_branch_pull_activate": self.on_menuitem_branch_pull_activate,
-                "on_menuitem_branch_update_activate": self.on_menuitem_branch_update_activate,                
-                "on_menuitem_branch_tags_activate": self.on_menuitem_branch_tags_activate,
-                "on_menuitem_branch_status_activate": self.on_menuitem_branch_status_activate,
-                "on_menuitem_branch_missing_revisions_activate": self.on_menuitem_branch_missing_revisions_activate,
-                "on_menuitem_branch_conflicts_activate": self.on_menuitem_branch_conflicts_activate,
-                "on_menuitem_stats_diff_activate": self.on_menuitem_stats_diff_activate,
-                "on_menuitem_stats_log_activate": self.on_menuitem_stats_log_activate,
-                "on_menuitem_stats_infos_activate": self.on_menuitem_stats_infos_activate,
-                "on_toolbutton_refresh_clicked": self.on_menuitem_view_refresh_activate,
-                "on_toolbutton_log_clicked": self.on_menuitem_stats_log_activate,
-                #"on_menutoolbutton_diff_clicked": self.on_menuitem_stats_diff_activate,
-                "on_toolbutton_diff_clicked": self.on_menuitem_stats_diff_activate,
-                "on_toolbutton_commit_clicked": self.on_menuitem_branch_commit_activate,
-                "on_toolbutton_pull_clicked": self.on_menuitem_branch_pull_activate,
-                "on_toolbutton_push_clicked": self.on_menuitem_branch_push_activate,
-                "on_toolbutton_update_clicked": self.on_menuitem_branch_update_activate,
-                "on_treeview_right_button_press_event": self.on_treeview_right_button_press_event,
-                "on_treeview_right_row_activated": self.on_treeview_right_row_activated,
-                "on_treeview_left_button_press_event": self.on_treeview_left_button_press_event,
-                "on_treeview_left_button_release_event": self.on_treeview_left_button_release_event,
-                "on_treeview_left_row_activated": self.on_treeview_left_row_activated,
-                "on_button_location_up_clicked": self.on_button_location_up_clicked,
-                "on_button_location_jump_clicked": self.on_button_location_jump_clicked,
-                "on_entry_location_key_press_event": self.on_entry_location_key_press_event,
-                "on_checkbutton_history_toggled": self.on_checkbutton_history_toggled,
-                "on_entry_history_revno_key_press_event": self.on_entry_history_revno_key_press_event,
-                "on_button_history_browse_clicked": self.on_button_history_browse_clicked
-            }
-        
-        # Connect the signals to the handlers
-        self.toplevel.signal_autoconnect(dic)
+        self.check_history = self.window.checkbutton_history
+        self.entry_history = self.window.entry_history_revno
+        self.button_history = self.window.button_history_browse
         
         self._just_started = True
         
@@ -222,11 +127,7 @@
         self.window.move(x, y)
         # Apply paned position
         pos = self.pref.get_preference('paned_position', 'int')
-        self.hpaned_main.set_position(pos)
-        
-        # Apply menu to the toolbutton
-        #menubutton = self.toplevel.get_widget('menutoolbutton_diff')
-        #menubutton.set_menu(handler.menu.toolbar_diff)
+        self.window.hpaned_main.set_position(pos)
         
         # Now we can show the window
         self.window.show()
@@ -238,11 +139,14 @@
             self.combobox_drive.show()
             self.gen_hard_selector()
         
+        # Acceptable errors when loading files/folders in the treeviews
+        self.acceptable_errors = (errno.ENOENT, errno.ELOOP)
+        
         self._load_left()
 
         # Apply menu state
-        self.menuitem_view_show_hidden_files.set_active(self.pref.get_preference('dotted_files', 'bool'))
-        self.menuitem_view_show_ignored_files.set_active(self.pref.get_preference('ignored_files', 'bool'))
+        self.window.mb_view_showhidden.set_active(self.pref.get_preference('dotted_files', 'bool'))
+        self.window.mb_view_showignored.set_active(self.pref.get_preference('ignored_files', 'bool'))
 
         # We're starting local
         self.remote = False
@@ -375,7 +279,7 @@
         else:
             self.check_history.set_sensitive(True)
         
-        self.statusbar.push(self.context_id, path)
+        self.window.statusbar.push(self.context_id, path)
         self.entry_location.set_text(path)
         self.path = path
         return True
@@ -408,6 +312,7 @@
             if response == gtk.RESPONSE_OK:
                 if revb.selected_revno is not None:
                     self.entry_history.set_text(revb.selected_revno)
+                    self.on_entry_history_revno_activate()
             
             revb.destroy()
     
@@ -438,39 +343,38 @@
             # History Mode activated
             self.entry_history.set_sensitive(True)
             self.button_history.set_sensitive(True)
+            if self.entry_history.get_text() != "":
+                self.on_entry_history_revno_activate()
         else:
             # History Mode deactivated
             self.entry_history.set_sensitive(False)
             self.button_history.set_sensitive(False)
+            
+            # Return right window to normal view by acting like we jump to it
+            self.on_button_location_jump_clicked(widget)
     
     @show_bzr_error
-    def on_entry_history_revno_key_press_event(self, widget, event):
+    def on_entry_history_revno_activate(self, widget=None):
         """ Key pressed handler for the history entry. """
-        if event.keyval == gtk.gdk.keyval_from_name('Return') or event.keyval == gtk.gdk.keyval_from_name('KP_Enter'):
-            # Return was hit, so we have to load that specific revision
-            # Emulate being remote, so inventory should be used
-            path = self.get_path()
-            if not self.remote:
-                self.remote = True
-                self.remote_branch = self.wt.branch
-            
-            revno = int(self.entry_history.get_text())
-            self.remote_revision = self.remote_branch.get_rev_id(revno)
-            if self.set_path(path, True):
-                self.refresh_right()
-    
-    def on_entry_location_key_press_event(self, widget, event):
-        """ Key pressed handler for the location entry. """
-        if event.keyval == gtk.gdk.keyval_from_name('Return') or event.keyval == gtk.gdk.keyval_from_name('KP_Enter'):
-            # Return was hit, so we have to jump
-            self.on_button_location_jump_clicked(widget)
-    
+        path = self.get_path()
+        if not self.remote:
+            self.remote = True
+            self.remote_branch = self.wt.branch
+        
+        revno = int(self.entry_history.get_text())
+        self.remote_revision = self.remote_branch.get_rev_id(revno)
+        if self.set_path(path, True):
+            self.refresh_right()
+
     def on_menuitem_add_files_activate(self, widget):
         """ Add file(s)... menu handler. """
-        from add import OliveAdd
-        add = OliveAdd(self.wt, self.wtpath, self.get_selected_right())
-        add.display()
-    
+        from bzrlib.plugins.gtk.olive.add import AddDialog
+        add = AddDialog(self.wt, self.wtpath, self.get_selected_right(), self.window)
+        response = add.run()
+        add.destroy()
+        if response == gtk.RESPONSE_OK:
+            self.refresh_right()
+
     def on_menuitem_branch_get_activate(self, widget):
         """ Branch/Get... menu handler. """
         from bzrlib.plugins.gtk.branch import BranchDialog
@@ -508,7 +412,6 @@
     @show_bzr_error
     def on_menuitem_branch_commit_activate(self, widget):
         """ Branch/Commit... menu handler. """
-#     def __init__(self, wt, wtpath, notbranch, selected=None, parent=None):
         selected = self.get_selected_right()
         if selected:
             selected = os.path.join(self.wtpath, selected)
@@ -541,8 +444,11 @@
                          _i18n('Please commit or revert the changes before merging.'))
         else:
             parent_branch_path = self.wt.branch.get_parent()
-            merge = MergeDialog(self.wt, self.wtpath,default_branch_path=parent_branch_path )
-            merge.display()
+            merge = MergeDialog(self.wt, self.wtpath, parent_branch_path, self.window)
+            response = merge.run()
+            merge.destroy()
+            if response == gtk.RESPONSE_OK:
+                self.refresh_right()
 
     @show_bzr_error
     def on_menuitem_branch_missing_revisions_activate(self, widget):
@@ -644,7 +550,7 @@
     @show_bzr_error
     def on_menuitem_branch_revert_activate(self, widget):
         """ Branch/Revert all changes menu handler. """
-        ret = self.wt.revert([])
+        ret = self.wt.revert(None)
         if ret:
             warning_dialog(_i18n('Conflicts detected'),
                            _i18n('Please have a look at the working tree before continuing.'))
@@ -716,26 +622,35 @@
     
     def on_menuitem_file_make_directory_activate(self, widget):
         """ File/Make directory... menu handler. """
-        from mkdir import OliveMkdir
-        mkdir = OliveMkdir(self.wt, self.wtpath)
-        mkdir.display()
+        from bzrlib.plugins.gtk.olive.mkdir import MkdirDialog
+        mkdir = MkdirDialog(self.wt, self.wtpath, self.window)
+        response = mkdir.run()
+        mkdir.destroy()
+        if response == gtk.RESPONSE_OK:
+            self.refresh_right()
     
     def on_menuitem_file_move_activate(self, widget):
         """ File/Move... menu handler. """
-        from move import OliveMove
-        move = OliveMove(self.wt, self.wtpath, self.get_selected_right())
-        move.display()
+        from bzrlib.plugins.gtk.olive.move import MoveDialog
+        move = MoveDialog(self.wt, self.wtpath, self.get_selected_right(), self.window)
+        response = move.run()
+        move.destroy()
+        if response == gtk.RESPONSE_OK:
+            self.refresh_right()
     
     def on_menuitem_file_rename_activate(self, widget):
         """ File/Rename... menu handler. """
-        from rename import OliveRename
-        rename = OliveRename(self.wt, self.wtpath, self.get_selected_right())
-        rename.display()
+        from bzrlib.plugins.gtk.olive.rename import RenameDialog
+        rename = RenameDialog(self.wt, self.wtpath, self.get_selected_right(), self.window)
+        response = rename.run()
+        rename.destroy()
+        if response == gtk.RESPONSE_OK:
+            self.refresh_right()
 
     def on_menuitem_remove_file_activate(self, widget):
         """ Remove (unversion) selected file. """
-        from remove import OliveRemoveDialog
-        remove = OliveRemoveDialog(self.wt, self.wtpath,
+        from bzrlib.plugins.gtk.olive.remove import RemoveDialog
+        remove = RemoveDialog(self.wt, self.wtpath,
                                    selected=self.get_selected_right(),
                                    parent=self.window)
         response = remove.run()
@@ -758,11 +673,11 @@
     
     def on_menuitem_stats_infos_activate(self, widget):
         """ Statistics/Informations... menu handler. """
-        from info import OliveInfo
+        from bzrlib.plugins.gtk.olive.info import InfoDialog
         if self.remote:
-            info = OliveInfo(self.remote_branch)
+            info = InfoDialog(self.remote_branch)
         else:
-            info = OliveInfo(self.wt.branch)
+            info = InfoDialog(self.wt.branch)
         info.display()
     
     def on_menuitem_stats_log_activate(self, widget):
@@ -773,7 +688,8 @@
         else:
             branch = self.remote_branch
 
-        window = branchwin.BranchWindow(branch, branch.last_revision(), None, parent=self.window)
+        window = branchwin.BranchWindow(branch, [branch.last_revision()], None, 
+                                        parent=self.window)
         window.show()
     
     def on_menuitem_view_refresh_activate(self, widget):
@@ -796,34 +712,34 @@
             self.refresh_right()
             
     def on_treeview_left_button_press_event(self, widget, event):
-        """ Occurs when somebody right-clicks in the bookmark list. """
-        if event.button == 3:
-            # Don't show context with nothing selected
-            if self.get_selected_left() == None:
-                return
-
-            # Create a menu
-            from menu import OliveMenu
-            menu = OliveMenu(path=self.get_path(),
-                             selected=self.get_selected_left(),
-                             app=self)
-            
-            menu.left_context_menu().popup(None, None, None, 0,
-                                           event.time)
-
-    def on_treeview_left_button_release_event(self, widget, event):
-        """ Occurs when somebody just clicks a bookmark. """
-        if event.button != 3:
-            # Allow one-click bookmark opening
-            if self.get_selected_left() == None:
-                return
-            
-            newdir = self.get_selected_left()
-            if newdir == None:
-                return
-
-            if self.set_path(newdir):
-                self.refresh_right()
+        """ Occurs when somebody clicks in the bookmark list. """
+        treepathpos = widget.get_path_at_pos(int(event.x), int(event.y))
+        treeselection = widget.get_selection()
+        if treepathpos is not None:
+            treeselection.select_path(treepathpos[0])
+            if event.button == 1:
+                newdir = self.get_selected_left()
+                if newdir == None:
+                    return
+
+                if self.set_path(newdir):
+                    self.refresh_right()
+            elif event.button == 3:
+                # Don't show context with nothing selected
+                if self.get_selected_left() == None:
+                    return
+
+                # Create a menu
+                from menu import OliveMenu
+                menu = OliveMenu(path=self.get_path(),
+                                 selected=self.get_selected_left(),
+                                 app=self)
+                
+                menu.left_context_menu().popup(None, None, None, 0,
+                                               event.time)
+        else:
+            if treeselection is not None:
+                treeselection.unselect_all()
 
     def on_treeview_left_row_activated(self, treeview, path, view_column):
         """ Occurs when somebody double-clicks or enters an item in the
@@ -837,8 +753,19 @@
             self.refresh_right()
 
     def on_treeview_right_button_press_event(self, widget, event):
-        """ Occurs when somebody right-clicks in the file list. """
-        if event.button == 3:
+        """ Occurs when somebody clicks in the file list. """
+        treepathpos = widget.get_path_at_pos(int(event.x), int(event.y))
+        if event.button == 1:
+            if treepathpos is None and widget.get_selection is not None:
+                treeselection = widget.get_selection()
+                treeselection.unselect_all()
+        elif event.button == 3:
+            treeselection = widget.get_selection()
+            if treepathpos is not None:
+                treeselection.select_path(treepathpos[0])
+            else:
+                if treeselection is not None:
+                    treeselection.unselect_all()
             # Create a menu
             from menu import OliveMenu
             menu = OliveMenu(path=self.get_path(),
@@ -848,6 +775,7 @@
             m_open = menu.ui.get_widget('/context_right/open')
             m_add = menu.ui.get_widget('/context_right/add')
             m_remove = menu.ui.get_widget('/context_right/remove')
+            m_remove_and_delete = menu.ui.get_widget('/context_right/remove_and_delete')
             m_rename = menu.ui.get_widget('/context_right/rename')
             m_revert = menu.ui.get_widget('/context_right/revert')
             m_commit = menu.ui.get_widget('/context_right/commit')
@@ -861,24 +789,40 @@
                     m_open.set_sensitive(False)
                     m_add.set_sensitive(False)
                     m_remove.set_sensitive(False)
+                    m_remove_and_delete.set_sensitive(False)
                     m_rename.set_sensitive(False)
                     m_revert.set_sensitive(False)
                     m_commit.set_sensitive(False)
                     m_annotate.set_sensitive(False)
                     m_diff.set_sensitive(False)
                 else:
+                    if treepathpos is None:
+                        m_open.set_sensitive(False)
+                        m_add.set_sensitive(False)
+                        m_remove.set_sensitive(False)
+                        m_remove_and_delete.set_sensitive(False)
+                        m_rename.set_sensitive(False)
+                        m_annotate.set_sensitive(False)
+                        m_diff.set_sensitive(False)
+                        m_revert.set_sensitive(False)
+                    else:
+                        m_open.set_sensitive(True)
+                        m_add.set_sensitive(True)
+                        m_remove.set_sensitive(True)
+                        m_remove_and_delete.set_sensitive(True)
+                        m_rename.set_sensitive(True)
+                        m_annotate.set_sensitive(True)
+                        m_diff.set_sensitive(True)
+                        m_revert.set_sensitive(True)
+                    m_commit.set_sensitive(True)
+            except bzrerrors.NotBranchError:
+                if treepathpos is None:
+                    m_open.set_sensitive(False)
+                else:
                     m_open.set_sensitive(True)
-                    m_add.set_sensitive(True)
-                    m_remove.set_sensitive(True)
-                    m_rename.set_sensitive(True)
-                    m_revert.set_sensitive(True)
-                    m_commit.set_sensitive(True)
-                    m_annotate.set_sensitive(True)
-                    m_diff.set_sensitive(True)
-            except bzrerrors.NotBranchError:
-                m_open.set_sensitive(True)
                 m_add.set_sensitive(False)
                 m_remove.set_sensitive(False)
+                m_remove_and_delete.set_sensitive(False)
                 m_rename.set_sensitive(False)
                 m_revert.set_sensitive(False)
                 m_commit.set_sensitive(False)
@@ -919,17 +863,17 @@
     
     def on_window_main_delete_event(self, widget, event=None):
         """ Do some stuff before exiting. """
-        width, height = self.window_main.get_size()
+        width, height = self.window.get_size()
         self.pref.set_preference('window_width', width)
         self.pref.set_preference('window_height', height)
-        x, y = self.window_main.get_position()
+        x, y = self.window.get_position()
         self.pref.set_preference('window_x', x)
         self.pref.set_preference('window_y', y)
         self.pref.set_preference('paned_position',
-                                 self.hpaned_main.get_position())
+                                 self.window.hpaned_main.get_position())
         
         self.pref.write()
-        self.window_main.destroy()
+        self.window.destroy()
         
     def _load_left(self):
         """ Load data into the left panel. (Bookmarks) """
@@ -941,9 +885,12 @@
         
         # Add them to the TreeStore
         titer = treestore.append(None, [_i18n('Bookmarks'), None])
-        for item in bookmarks:
-            title = self.pref.get_bookmark_title(item)
-            treestore.append(titer, [title, item])
+
+        # Get titles and sort by title
+        bookmarks = [[self.pref.get_bookmark_title(item), item] for item in bookmarks]
+        bookmarks.sort()
+        for title_item in bookmarks:
+            treestore.append(titer, title_item)
         
         # Create the column and add it to the TreeView
         self.treeview_left.set_model(treestore)
@@ -997,7 +944,7 @@
             try:
                 statinfo = os.stat(self.path + os.sep + item)
             except OSError, e:
-                if e.errno == 40:
+                if e.errno in self.acceptable_errors:
                     continue
                 else:
                     raise
@@ -1064,7 +1011,7 @@
             try:
                 statinfo = os.stat(self.path + os.sep + item)
             except OSError, e:
-                if e.errno == 40:
+                if e.errno in self.acceptable_errors:
                     continue
                 else:
                     raise
@@ -1155,74 +1102,18 @@
 
     def set_statusbar(self, message):
         """ Set the statusbar message. """
-        self.statusbar.push(self.context_id, message)
+        self.window.statusbar.push(self.context_id, message)
     
     def clear_statusbar(self):
         """ Clean the last message from the statusbar. """
-        self.statusbar.pop(self.context_id)
+        self.window.statusbar.pop(self.context_id)
     
     def set_sensitivity(self):
         """ Set menu and toolbar sensitivity. """
         if not self.remote:
-            # We're local
-            self.menuitem_branch_init.set_sensitive(self.notbranch)
-            self.menuitem_branch_get.set_sensitive(self.notbranch)
-            self.menuitem_branch_checkout.set_sensitive(self.notbranch)
-            self.menuitem_branch_pull.set_sensitive(not self.notbranch)
-            self.menuitem_branch_push.set_sensitive(not self.notbranch)
-            self.menuitem_branch_update.set_sensitive(not self.notbranch)
-            self.menuitem_branch_revert.set_sensitive(not self.notbranch)
-            self.menuitem_branch_merge.set_sensitive(not self.notbranch)
-            self.menuitem_branch_commit.set_sensitive(not self.notbranch)
-            self.menuitem_branch_tags.set_sensitive(not self.notbranch)
-            self.menuitem_branch_status.set_sensitive(not self.notbranch)
-            self.menuitem_branch_missing.set_sensitive(not self.notbranch)
-            self.menuitem_branch_conflicts.set_sensitive(not self.notbranch)
-            self.menuitem_stats.set_sensitive(not self.notbranch)
-            self.menuitem_stats_diff.set_sensitive(not self.notbranch)
-            self.menuitem_add_files.set_sensitive(not self.notbranch)
-            self.menuitem_remove_files.set_sensitive(not self.notbranch)
-            self.menuitem_file_make_directory.set_sensitive(not self.notbranch)
-            self.menuitem_file_rename.set_sensitive(not self.notbranch)
-            self.menuitem_file_move.set_sensitive(not self.notbranch)
-            self.menuitem_file_annotate.set_sensitive(not self.notbranch)
-            #self.menutoolbutton_diff.set_sensitive(True)
-            self.toolbutton_diff.set_sensitive(not self.notbranch)
-            self.toolbutton_log.set_sensitive(not self.notbranch)
-            self.toolbutton_commit.set_sensitive(not self.notbranch)
-            self.toolbutton_pull.set_sensitive(not self.notbranch)
-            self.toolbutton_push.set_sensitive(not self.notbranch)
-            self.toolbutton_update.set_sensitive(not self.notbranch)
+            self.window.set_view_to_localbranch(self.notbranch)
         else:
-            # We're remote
-            self.menuitem_branch_init.set_sensitive(False)
-            self.menuitem_branch_get.set_sensitive(True)
-            self.menuitem_branch_checkout.set_sensitive(True)
-            self.menuitem_branch_pull.set_sensitive(False)
-            self.menuitem_branch_push.set_sensitive(False)
-            self.menuitem_branch_update.set_sensitive(False)
-            self.menuitem_branch_revert.set_sensitive(False)
-            self.menuitem_branch_merge.set_sensitive(False)
-            self.menuitem_branch_commit.set_sensitive(False)
-            self.menuitem_branch_tags.set_sensitive(True)
-            self.menuitem_branch_status.set_sensitive(False)
-            self.menuitem_branch_missing.set_sensitive(False)
-            self.menuitem_branch_conflicts.set_sensitive(False)
-            self.menuitem_stats.set_sensitive(True)
-            self.menuitem_stats_diff.set_sensitive(False)
-            self.menuitem_add_files.set_sensitive(False)
-            self.menuitem_remove_files.set_sensitive(False)
-            self.menuitem_file_make_directory.set_sensitive(False)
-            self.menuitem_file_rename.set_sensitive(False)
-            self.menuitem_file_move.set_sensitive(False)
-            self.menuitem_file_annotate.set_sensitive(False)
-            #self.menutoolbutton_diff.set_sensitive(True)
-            self.toolbutton_diff.set_sensitive(False)
-            self.toolbutton_log.set_sensitive(True)
-            self.toolbutton_commit.set_sensitive(False)
-            self.toolbutton_pull.set_sensitive(False)
-            self.toolbutton_push.set_sensitive(False)
-            self.toolbutton_update.set_sensitive(False)
+            self.window.set_view_to_remotebranch()
     
     def refresh_left(self):
         """ Refresh the bookmark list. """
@@ -1239,10 +1130,13 @@
 
         # Add them to the TreeStore
         titer = treestore.append(None, [_i18n('Bookmarks'), None])
-        for item in bookmarks:
-            title = self.pref.get_bookmark_title(item)
-            treestore.append(titer, [title, item])
 
+        # Get titles and sort by title
+        bookmarks = [[self.pref.get_bookmark_title(item), item] for item in bookmarks]
+        bookmarks.sort()
+        for title_item in bookmarks:
+            treestore.append(titer, title_item)
+        
         # Add the TreeStore to the TreeView
         self.treeview_left.set_model(treestore)
 
@@ -1302,7 +1196,7 @@
                 try:
                     statinfo = os.stat(self.path + os.sep + item)
                 except OSError, e:
-                    if e.errno == 40:
+                    if e.errno in self.acceptable_errors:
                         continue
                     else:
                         raise
@@ -1371,7 +1265,7 @@
                 try:
                     statinfo = os.stat(self.path + os.sep + item)
                 except OSError, e:
-                    if e.errno == 40:
+                    if e.errno in self.acceptable_errors:
                         continue
                     else:
                         raise
@@ -1480,12 +1374,11 @@
             if sys.platform == 'win32':
                 print "pyWin32 modules needed to run Olive on Win32."
                 sys.exit(1)
-            else:
-                pass
         
         driveletters = []
         for drive in string.ascii_uppercase:
-            if win32file.GetDriveType(drive+':') == win32file.DRIVE_FIXED:
+            if win32file.GetDriveType(drive+':') == win32file.DRIVE_FIXED or\
+                win32file.GetDriveType(drive+':') == win32file.DRIVE_REMOTE:
                 driveletters.append(drive+':')
         return driveletters
     
@@ -1724,4 +1617,3 @@
                 return self._get_default(option)
             except KeyError:
                 return None
- 

=== modified file 'olive/add.py'
--- olive/add.py	2008-05-05 18:16:46 +0000
+++ olive/add.py	2008-07-17 20:41:24 +0000
@@ -23,44 +23,52 @@
     pass
 
 import gtk
-import gtk.glade
 
 import bzrlib.add
 import bzrlib.errors as errors
 
 from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog
-from guifiles import GLADEFILENAME
-
-
-class OliveAdd:
-    """ Display the Add file(s) dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath, selected=[]):
-        """ Initialize the Add file(s) dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_add', 'olive-gtk')
-        
-        self.window = self.glade.get_widget('window_add')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_add_add_clicked": self.add,
-                "on_button_add_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-
+from bzrlib.plugins.gtk.errors import show_bzr_error
+
+
+class AddDialog(gtk.Dialog):
+    """ Dialog for adding selected file or recursively all unknown files/folders in branch """
+    
+    def __init__(self, wt, wtpath, selected, parent=None):
+        """ Initialize the Add dialog. """
+        gtk.Dialog.__init__(self, title="Olive - Add file(s)",
+                                  parent=parent,
+                                  flags=0,
+                                  buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+        
+        # Get arguments
         self.wt = wt
         self.wtpath = wtpath
         self.selected = selected
-
-    def display(self):
-        """ Display the Add file(s) dialog. """
-        self.window.show_all()
-        
-    def add(self, widget):
-        radio_selected = self.glade.get_widget('radiobutton_add_selected')
-        radio_unknown = self.glade.get_widget('radiobutton_add_unknown')
-        
-        if radio_selected.get_active():
+        
+        # Create widgets
+        self._label_add_question = gtk.Label(_i18n("Which file(s) do you want to add?"))
+        self._radiobutton_add_selected = gtk.RadioButton(None,_i18n("Selected: %s"%self.selected))
+        self._radiobutton_add_unknown = gtk.RadioButton(self._radiobutton_add_selected, 
+                                                        _i18n("All unknowns recursively"))
+        self._button_add = gtk.Button(stock=gtk.STOCK_ADD)        
+        
+        self._button_add.connect('clicked', self._on_add_clicked)
+        
+        # Add widgets to dialog window and decorate
+        self.vbox.add(self._label_add_question)
+        self.vbox.add(self._radiobutton_add_selected)
+        self.vbox.add(self._radiobutton_add_unknown)
+        self.vbox.set_spacing(3)
+        self.action_area.pack_end(self._button_add)
+        
+        self.vbox.show_all()
+        
+    @show_bzr_error
+    def _on_add_clicked(self, button):
+        """ """
+        if self._radiobutton_add_selected.get_active():
             # Add only the selected file
             filename = self.selected
             
@@ -69,26 +77,19 @@
                              _i18n('Please select a file from the list,\nor choose the other option.'))
                 return
             
-            fullpath = self.wt.abspath(os.path.join(self.wtpath, filename))
-            
             try:
-                bzrlib.add.smart_add([fullpath])
+                self.wt.add([filename])
             except errors.NotBranchError:
                 error_dialog(_i18n('Directory is not a branch'),
                              _i18n('You can perform this action only in a branch.'))
                 return
-        elif radio_unknown.get_active():
+        elif self._radiobutton_add_unknown.get_active():
             # Add unknown files recursively
-            fullpath = self.wt.abspath(self.wtpath)
-            
             try:
-                bzrlib.add.smart_add([fullpath], True)
+                self.wt.add(self.wt.unknowns())
             except errors.NotBranchError:
                 error_dialog(_i18n('Directory is not a branch'),
                              _i18n('You can perform this action only in a branch.'))
                 return
         
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()
+        self.response(gtk.RESPONSE_OK)

=== modified file 'olive/bookmark.py'
--- olive/bookmark.py	2008-05-05 18:16:46 +0000
+++ olive/bookmark.py	2008-07-20 22:36:42 +0000
@@ -22,7 +22,7 @@
 
 import gtk
 
-from olive import Preferences
+from bzrlib.plugins.gtk.olive import Preferences
 from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog
 
@@ -57,6 +57,8 @@
         self._entry_title.set_text(self.pref.get_bookmark_title(self.selected))
         self._entry_title.set_flags(gtk.CAN_FOCUS | gtk.HAS_FOCUS)
         
+        self._entry_title.connect('activate', self._on_save_clicked)
+        
         # Create a table and put widgets into it
         self._table = gtk.Table(rows=2, columns=2)
         self._table.attach(self._label_location, 0, 1, 0, 1)

=== modified file 'olive/guifiles.py'
--- olive/guifiles.py	2008-05-05 18:16:46 +0000
+++ olive/guifiles.py	2008-07-22 08:01:14 +0000
@@ -12,50 +12,38 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Glade file name"""
+"""cmenu.ui path"""
 
 import os
 import sys
 
 from bzrlib.plugins.gtk import _i18n
 
-GLADEFILENAMES = ["/usr/share/olive/olive.glade",
-                  "/usr/local/share/olive/olive.glade",
-                  "/opt/share/olive/olive.glade",
-                  "/opt/local/share/olive/olive.glade",
-                  "~/share/olive/olive.glade",
+UIFILENAMES = ["/usr/share/olive/cmenu.ui",
+                  "/usr/local/share/olive/cmenu.ui",
+                  "/opt/share/olive/cmenu.ui",
+                  "/opt/local/share/olive/cmenu.ui",
+                  "~/share/olive/cmenu.ui",
                  ]
 
 # Get the glade file name
 if sys.platform == 'win32':
-    GLADEFILENAMES = [os.path.join(os.path.dirname(sys.executable),
-                                   "share/olive/olive.glade")]
+    UIFILENAMES = [os.path.join(os.path.dirname(sys.executable),
+                                   "share/olive/cmenu.ui")]
 
 dir_ = os.path.split(os.path.dirname(__file__))[0]
 # Check first if we are running from source
-GLADEFILENAMES.insert(0, os.path.join(dir_, "olive.glade"))
-
-GLADEFILENAME = None
-
-for path in GLADEFILENAMES:
+UIFILENAMES.insert(0, os.path.join(dir_, "cmenu.ui"))
+
+UIFILENAME = None
+
+for path in UIFILENAMES:
     path = os.path.expanduser(path)
     if os.path.isfile(path):
-        GLADEFILENAME = path
+        UIFILENAME = path
         break
 
-if GLADEFILENAME is None:
-    # Fail
-    print _i18n('Glade file cannot be found.')
-    sys.exit(1)
-
-UIFILEDIR = os.path.dirname(GLADEFILENAME)
-
-# Get the cmenu.ui file name
-UIFILENAME = os.path.join(UIFILEDIR, 'cmenu.ui')
-
-if not os.path.isfile(UIFILENAME):
-    # Fail
-    print _i18n('UI description file cannot be found.')
-    sys.exit(1)
-
-
+if UIFILENAME is None:
+    # Fail
+    print _i18n('Context menu file (cmenu.ui) cannot be found.')
+    sys.exit(1)

=== modified file 'olive/info.py'
--- olive/info.py	2008-05-05 18:16:46 +0000
+++ olive/info.py	2008-07-20 16:23:24 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+import os
+
 try:
     import pygtk
     pygtk.require("2.0")
@@ -21,13 +23,11 @@
     pass
 
 import gtk
-import gtk.glade
 
 import bzrlib.errors as errors
 
-from bzrlib.plugins.gtk import _i18n
+from bzrlib.plugins.gtk import _i18n, icon_path
 from bzrlib.plugins.gtk.dialog import error_dialog
-from guifiles import GLADEFILENAME
 
 
 def info(location):
@@ -137,21 +137,16 @@
             ret['repstats'] = info_helper.get_repository_stats(repository)
         finally:
             repository.unlock()
-            return ret
-        return
+        return ret
     except errors.NoRepositoryPresent:
         pass
 
 
-class OliveInfo:
+class InfoDialog(object):
     """ Display Informations window and perform the needed actions. """
+    
     def __init__(self, branch):
         """ Initialize the Informations window. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_info', 'olive-gtk')
-        
-        # Get the Informations window widget
-        self.window = self.glade.get_widget('window_info')
-        
         # Check if current location is a branch
         self.notbranch = False
         try:
@@ -160,391 +155,111 @@
             self.notbranch = True
             return
         
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_info_close_clicked": self.close,
-                "on_expander_info_location_activate": self.activate,
-                "on_expander_info_related_activate": self.activate,
-                "on_expander_info_format_activate": self.activate,
-                "on_expander_info_locking_activate": self.activate,
-                "on_expander_info_missing_activate": self.activate,
-                "on_expander_info_wtstats_activate": self.activate,
-                "on_expander_info_brstats_activate": self.activate,
-                "on_expander_info_repstats_activate": self.activate }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
+        # Create the window
+        self.window = gtk.Dialog(title="Olive - Information",
+                                  parent = None,
+                                  flags=0,
+                                  buttons=None)
+        self.window.set_icon_list(gtk.gdk.pixbuf_new_from_file(icon_path("oliveicon2.png")),
+                                  gtk.gdk.pixbuf_new_from_file(icon_path("olive-gtk.png")))
+        self.window.vbox.set_spacing(3)
+        self.window.set_type_hint(gtk.gdk.WINDOW_TYPE_HINT_NORMAL)
+        
+        infokeylist = ( ('location', _i18n("Location"), (
+                            ('lightcoroot', _i18n("Light checkout root")),
+                            ('sharedrepo', _i18n("Shared repository")),
+                            ('repobranch', _i18n("Repository branch")),
+                            ('cobranch', _i18n("Checkout of branch")),
+                            ('repoco', _i18n("Repository checkout")),
+                            ('coroot', _i18n("Checkout root")),
+                            ('branchroot', _i18n("Branch root")),
+                            )),
+                        ('related', _i18n("Related branches"), (
+                            ('parentbranch', _i18n("Parent branch")),
+                            ('publishbranch', _i18n("Publish to branch")),
+                            )),
+                        ('format', _i18n("Format"), (
+                            ('control', _i18n("Control format")),
+                            ('workingtree', _i18n("Working tree format")),
+                            ('branch', _i18n("Branch format")),
+                            ('repository', _i18n("Repository format")),
+                            )),
+                        ('locking', _i18n("Lock status"), (
+                            ('workingtree', _i18n("Working tree lock status")),
+                            ('branch', _i18n("Branch lock status")),
+                            ('repository', _i18n("Repository lock status")),
+                            )),
+                        #('missing', _i18n("Missing revisions"), (
+                        #    ('branch', _i18n("Missing revisions in branch")),
+                        #    ('workingtree', _i18n("Missing revisions in working tree")),
+                        #    )), # Missing is 'temporary' disabled
+                        ('wtstats', _i18n("In the working tree"), (
+                            ('unchanged', _i18n("Unchanged files")),
+                            ('modified', _i18n("Modified files")),
+                            ('added', _i18n("Added files")),
+                            ('removed', _i18n("Removed files")),
+                            ('renamed', _i18n("Renamed files")),
+                            ('unknown', _i18n("Unknown files")),
+                            ('ignored', _i18n("Ignored files")),
+                            ('subdirs', _i18n("Versioned subdirectories")),
+                            )),
+                        ('brstats', _i18n("Branch history"), (
+                            ('revno', _i18n("Revisions in branch")),
+                            ('commiters', _i18n("Number of commiters")),
+                            ('age', _i18n("Age of branch in days")),
+                            ('firstrev', _i18n("Time of first revision")),
+                            ('lastrev', _i18n("Time of last revision")),
+                            )),
+                        ('repstats', _i18n("Revision store"), (
+                            ('revisions', _i18n("Revisions in repository")),
+                            ('size', _i18n("Size of repository in bytes")),
+                            )),
+                        )
+               
         # Generate status output
-        self._generate_info()
-
-    def _generate_info(self):
+        self._generate_info(infokeylist)
+        
+        button_close = gtk.Button(stock=gtk.STOCK_CLOSE)        
+        button_close.connect('clicked', self.close)
+        self.window.action_area.pack_end(button_close)
+        self.window.set_focus(button_close)
+    
+    def _generate_info(self, infokeylist):
         """ Generate 'bzr info' output. """
-        # location
-        if self.ret.has_key('location'):
-            display = False
-            e = self.glade.get_widget('expander_info_location')
-            if self.ret['location'].has_key('lightcoroot'):
-                ll = self.glade.get_widget('label_info_location_lightcoroot_label')
-                l = self.glade.get_widget('label_info_location_lightcoroot')
-                l.set_text(self.ret['location']['lightcoroot'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('sharedrepo'):
-                ll = self.glade.get_widget('label_info_location_sharedrepo_label')
-                l = self.glade.get_widget('label_info_location_sharedrepo')
-                l.set_text(self.ret['location']['sharedrepo'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('repobranch'):
-                ll = self.glade.get_widget('label_info_location_repobranch_label')
-                l = self.glade.get_widget('label_info_location_repobranch')
-                l.set_text(self.ret['location']['repobranch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('cobranch'):
-                ll = self.glade.get_widget('label_info_location_cobranch_label')
-                l = self.glade.get_widget('label_info_location_cobranch')
-                l.set_text(self.ret['location']['cobranch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('repoco'):
-                ll = self.glade.get_widget('label_info_location_repoco_label')
-                l = self.glade.get_widget('label_info_location_repoco')
-                l.set_text(self.ret['location']['repoco'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('coroot'):
-                ll = self.glade.get_widget('label_info_location_coroot_label')
-                l = self.glade.get_widget('label_info_location_coroot')
-                l.set_text(self.ret['location']['coroot'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('branchroot'):
-                ll = self.glade.get_widget('label_info_location_branchroot_label')
-                l = self.glade.get_widget('label_info_location_branchroot')
-                l.set_text(self.ret['location']['branchroot'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # related
-        if self.ret.has_key('related'):
-            display = False
-            e = self.glade.get_widget('expander_info_related')
-            if self.ret['related'].has_key('parentbranch'):
-                ll = self.glade.get_widget('label_info_related_parentbranch_label')
-                l = self.glade.get_widget('label_info_related_parentbranch')
-                l.set_text(self.ret['related']['parentbranch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['related'].has_key('publishbranch'):
-                ll = self.glade.get_widget('label_info_related_publishbranch_label')
-                l = self.glade.get_widget('label_info_related_publishbranch')
-                l.set_text(self.ret['related']['publishbranch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # format
-        if self.ret.has_key('format'):
-            display = False
-            e = self.glade.get_widget('expander_info_format')
-            if self.ret['format'].has_key('control'):
-                ll = self.glade.get_widget('label_info_format_control_label')
-                l = self.glade.get_widget('label_info_format_control')
-                l.set_text(self.ret['format']['control'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['format'].has_key('workingtree'):
-                ll = self.glade.get_widget('label_info_format_workingtree_label')
-                l = self.glade.get_widget('label_info_format_workingtree')
-                l.set_text(self.ret['format']['workingtree'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['format'].has_key('branch'):
-                ll = self.glade.get_widget('label_info_format_branch_label')
-                l = self.glade.get_widget('label_info_format_branch')
-                l.set_text(self.ret['format']['branch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['format'].has_key('repository'):
-                ll = self.glade.get_widget('label_info_format_repository_label')
-                l = self.glade.get_widget('label_info_format_repository')
-                l.set_text(self.ret['format']['repository'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # locking
-        if self.ret.has_key('locking'):
-            display = False
-            e = self.glade.get_widget('expander_info_locking')
-            if self.ret['locking'].has_key('workingtree'):
-                ll = self.glade.get_widget('label_info_locking_workingtree_label')
-                l = self.glade.get_widget('label_info_locking_workingtree')
-                l.set_text(self.ret['locking']['workingtree'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['locking'].has_key('branch'):
-                ll = self.glade.get_widget('label_info_locking_branch_label')
-                l = self.glade.get_widget('label_info_locking_branch')
-                l.set_text(self.ret['locking']['branch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['locking'].has_key('repository'):
-                ll = self.glade.get_widget('label_info_locking_repository_label')
-                l = self.glade.get_widget('label_info_locking_repository')
-                l.set_text(self.ret['locking']['repository'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # missing - temporary disabled
-        """
-        if self.ret.has_key('missing'):
-            display = False
-            e = self.glade.get_widget('expander_info_missing')
-            if self.ret['missing'].has_key('branch'):
-                ll = self.glade.get_widget('label_info_missing_branch_label')
-                l = self.glade.get_widget('label_info_missing_branch')
-                l.set_text(self.ret['missing']['branch'])
-                ll.set_markup('<b>' + ll.get_text() + '</b>')
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['missing'].has_key('workingtree'):
-                ll = self.glade.get_widget('label_info_missing_workingtree_label')
-                l = self.glade.get_widget('label_info_missing_workingtree')
-                l.set_text(self.ret['missing']['branch'])
-                ll.set_markup('<b>' + ll.get_text() + '</b>')
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        """
-        # working tree stats
-        if self.ret.has_key('wtstats'):
-            display = False
-            e = self.glade.get_widget('expander_info_wtstats')
-            if self.ret['wtstats'].has_key('unchanged'):
-                ll = self.glade.get_widget('label_info_wtstats_unchanged_label')
-                l = self.glade.get_widget('label_info_wtstats_unchanged')
-                l.set_text(str(self.ret['wtstats']['unchanged']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('modified'):
-                ll = self.glade.get_widget('label_info_wtstats_modified_label')
-                l = self.glade.get_widget('label_info_wtstats_modified')
-                l.set_text(str(self.ret['wtstats']['modified']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('added'):
-                ll = self.glade.get_widget('label_info_wtstats_added_label')
-                l = self.glade.get_widget('label_info_wtstats_added')
-                l.set_text(str(self.ret['wtstats']['added']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('removed'):
-                ll = self.glade.get_widget('label_info_wtstats_removed_label')
-                l = self.glade.get_widget('label_info_wtstats_removed')
-                l.set_text(str(self.ret['wtstats']['removed']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('renamed'):
-                ll = self.glade.get_widget('label_info_wtstats_renamed_label')
-                l = self.glade.get_widget('label_info_wtstats_renamed')
-                l.set_text(str(self.ret['wtstats']['renamed']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('unknown'):
-                ll = self.glade.get_widget('label_info_wtstats_unknown_label')
-                l = self.glade.get_widget('label_info_wtstats_unknown')
-                l.set_text(str(self.ret['wtstats']['unknown']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('ignored'):
-                ll = self.glade.get_widget('label_info_wtstats_ignored_label')
-                l = self.glade.get_widget('label_info_wtstats_ignored')
-                l.set_text(str(self.ret['wtstats']['ignored']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('subdirs'):
-                ll = self.glade.get_widget('label_info_wtstats_subdirs_label')
-                l = self.glade.get_widget('label_info_wtstats_subdirs')
-                l.set_text(str(self.ret['wtstats']['subdirs']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # branch stats
-        if self.ret.has_key('brstats'):
-            display = False
-            e = self.glade.get_widget('expander_info_brstats')
-            if self.ret['brstats'].has_key('revno'):
-                ll = self.glade.get_widget('label_info_brstats_revno_label')
-                l = self.glade.get_widget('label_info_brstats_revno')
-                l.set_text(str(self.ret['brstats']['revno']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['brstats'].has_key('commiters'):
-                ll = self.glade.get_widget('label_info_brstats_commiters_label')
-                l = self.glade.get_widget('label_info_brstats_commiters')
-                l.set_text(str(self.ret['brstats']['commiters']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['brstats'].has_key('age'):
-                ll = self.glade.get_widget('label_info_brstats_age_label')
-                l = self.glade.get_widget('label_info_brstats_age')
-                l.set_text('%d days' % self.ret['brstats']['age'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['brstats'].has_key('firstrev'):
-                ll = self.glade.get_widget('label_info_brstats_firstrev_label')
-                l = self.glade.get_widget('label_info_brstats_firstrev')
-                l.set_text(self.ret['brstats']['firstrev'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['brstats'].has_key('lastrev'):
-                ll = self.glade.get_widget('label_info_brstats_lastrev_label')
-                l = self.glade.get_widget('label_info_brstats_lastrev')
-                l.set_text(self.ret['brstats']['lastrev'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # repository stats
-        if self.ret.has_key('repstats'):
-            display = False
-            e = self.glade.get_widget('expander_info_repstats')
-            if self.ret['repstats'].has_key('revisions'):
-                ll = self.glade.get_widget('label_info_repstats_revisions_label')
-                l = self.glade.get_widget('label_info_repstats_revisions')
-                l.set_text(str(self.ret['repstats']['revisions']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['repstats'].has_key('size'):
-                ll = self.glade.get_widget('label_info_repstats_size_label')
-                l = self.glade.get_widget('label_info_repstats_size')
-                l.set_text('%d KiB' % (self.ret['repstats']['size'] / 1024))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
+        for key, keystring, subkeylist in infokeylist:
+            if self.ret.has_key(key):
+                tablelength = 0
+                for subkey, subkeystring in subkeylist:
+                    if self.ret[key].has_key(subkey):
+                        tablelength += 1
+                if tablelength == 0:
+                    pass
+                else:
+                    exec "exp_%s = gtk.Expander('<b>%s</b>')"%(key, keystring)
+                    eval("exp_%s.set_use_markup(True)"%key)
+                    eval("exp_%s.connect('activate', self.activate)"%key)
+                    
+                    exec "alignment_%s = gtk.Alignment()"%key
+                    eval("alignment_%s.set_padding(0, 0, 24, 0)"%key)
+                    eval("exp_%s.add(alignment_%s)"%(key, key))
+                    
+                    exec "table_%s = gtk.Table(tablelength, 2)"%key
+                    eval("table_%s.set_col_spacings(12)"%key)
+                    eval("alignment_%s.add(table_%s)"%(key, key))
+                    
+                    tablepos = 0
+                    for subkey, subkeystring in subkeylist:
+                        if self.ret[key].has_key(subkey):
+                            exec "%s_%s_label = gtk.Label('%s:')"%(key,subkey, subkeystring)
+                            eval("table_%s.attach(%s_%s_label, 0, 1, %i, %i, gtk.FILL)"%(key, key, subkey, tablepos, tablepos + 1))
+                            eval("%s_%s_label.set_alignment(0, 0.5)"%(key, subkey))
+                            
+                            exec "%s_%s = gtk.Label('%s')"%(key, subkey, str(self.ret[key][subkey]))
+                            eval("table_%s.attach(%s_%s, 1, 2, %i, %i, gtk.FILL)"%(key, key, subkey, tablepos, tablepos + 1))
+                            eval("%s_%s.set_alignment(0, 0.5)"%(key, subkey))
+                            tablepos += 1
+                    eval("exp_%s.set_expanded(True)"%key)
+                    eval("self.window.vbox.pack_start(exp_%s, False, True, 0)"%key)
     
     def activate(self, expander):
         """ Redraw the window. """
@@ -558,7 +273,7 @@
                          _i18n('You can perform this action only in a branch.'))
             self.close()
         else:
-            self.window.show()
-
+            self.window.show_all()
+    
     def close(self, widget=None):
         self.window.destroy()

=== modified file 'olive/info_helper.py'
--- olive/info_helper.py	2007-08-12 21:14:51 +0000
+++ olive/info_helper.py	2008-07-19 23:16:51 +0000
@@ -17,6 +17,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import time
+import sys
 
 import bzrlib
 
@@ -28,8 +29,9 @@
     urlutils,
     )
 
+from bzrlib.diff import show_diff_trees
 from bzrlib.missing import find_unmerged
-
+    
 def _repo_rel_url(repo_url, inner_url):
     """Return path with common prefix of repository path removed.
 
@@ -260,7 +262,7 @@
     if revno > 0:
         firstrev = repository.get_revision(history[0])
         age = int((time.time() - firstrev.timestamp) / 3600 / 24)
-        ret['age'] = age
+        ret['age'] = '%d days'%age
         ret['firstrev'] = osutils.format_date(firstrev.timestamp,
                                               firstrev.timezone)
 
@@ -279,7 +281,7 @@
     if repository.bzrdir.root_transport.listable():
         c, t = repository._revision_store.total_size(repository.get_transaction())
         ret['revisions'] = c
-        ret['size'] = t
+        ret['size'] = '%d KiB'%t
 
     return ret
 
@@ -298,17 +300,10 @@
 
     :param new_revision_spec:  if None, use working tree as new revision, otherwise use the tree for the specified revision.
     """
-    import sys
-    
-    from bzrlib.diff import show_diff_trees
     
     if output == None:
         output = sys.stdout
     
-    def spec_tree(spec):
-        revision_id = spec.in_store(tree.branch).rev_id
-        return tree.branch.repository.revision_tree(revision_id)
-    
     if old_revision_spec is None:
         old_tree = tree.basis_tree()
     else:
@@ -322,3 +317,7 @@
     return show_diff_trees(old_tree, new_tree, output, specific_files,
                            external_diff_options,
                            old_label=old_label, new_label=new_label)
+
+def spec_tree(spec):
+        revision_id = spec.in_store(tree.branch).rev_id
+        return tree.branch.repository.revision_tree(revision_id)

=== modified file 'olive/menu.py'
--- olive/menu.py	2008-05-05 18:18:08 +0000
+++ olive/menu.py	2008-07-24 19:33:17 +0000
@@ -36,8 +36,7 @@
 from bzrlib.plugins.gtk.annotate.gannotate import GAnnotateWindow
 from bzrlib.plugins.gtk.annotate.config import GAnnotateConfig
 from bzrlib.plugins.gtk.diff import DiffWindow
-from launch import launch
-from bzrlib.plugins.gtk.olive import Preferences
+from bzrlib.plugins.gtk.olive import Preferences, launch
 
 class OliveMenu:
     """ This class is responsible for building the context menus. """
@@ -179,7 +178,10 @@
                          _i18n('Please select a file from the list,\nor choose the other option.'))
             return
         
-        bzrlib.add.smart_add([os.path.join(directory, filename)])
+        wt, path = WorkingTree.open_containing(os.path.join(directory, filename))
+        wt.add([path])
+        
+        self.app.refresh_right()
     
     @show_bzr_error
     def annotate(self, action):
@@ -196,7 +198,8 @@
         
         branch = wt.branch
         file_id = wt.path2id(wt.relpath(os.path.join(directory, filename)))
-        
+        if file_id is None:
+            raise errors.NotVersionedError(filename)
         window = GAnnotateWindow(all=False, plain=False, parent=self.app)
         window.set_title(os.path.join(directory, filename) + " - Annotate")
         config = GAnnotateConfig(window)
@@ -208,7 +211,7 @@
             branch.unlock()
     
     @show_bzr_error
-    def remove_file(self, action,delete_on_disk=0):
+    def remove_file(self, action, delete_on_disk=False):
         """ Right context menu -> Remove """
         # Remove only the selected file
         directory = self.path
@@ -236,14 +239,17 @@
         
     def remove_and_delete_file(self, action):
         """ Right context menu -> Remove and delete"""
-        self.remove_file(action,delete_on_disk=1)
+        self.remove_file(action, delete_on_disk=True)
 
     def rename_file(self, action):
         """ Right context menu -> Rename """
-        from rename import OliveRename
-        wt = WorkingTree.open_containing(self.path + os.sep + self.selected)[0]
-        rename = OliveRename(wt, wt.relpath(self.path), self.selected)
-        rename.display()
+        from bzrlib.plugins.gtk.olive.rename import RenameDialog
+        wt = WorkingTree.open_containing(os.path.join(self.path, self.selected))[0]
+        rename = RenameDialog(wt, wt.relpath(self.path), self.selected)
+        response = rename.run()
+        rename.destroy()
+        if response == gtk.RESPONSE_OK:
+            self.app.refresh_right()
     
     def open_file(self, action):
         """ Right context menu -> Open """
@@ -259,13 +265,8 @@
             # TODO: how to enter a directory?
             return
         else:
-            fullpath = self.path + os.sep + filename
-            if os.path.isdir(fullpath):
-                # selected item is an existant directory
-                # TODO: how to enter a directory?
-                return
-            else:
-                launch(fullpath) 
+            fullpath = os.path.join(self.path, filename)
+            launch.launch(fullpath) 
 
     def revert(self, action):
         """ Right context menu -> Revert """
@@ -276,7 +277,7 @@
                            _i18n('Please have a look at the working tree before continuing.'))
         else:
             info_dialog(_i18n('Revert successful'),
-                        _i18n('All files reverted to last revision.'))
+                        _i18n('Selected file reverted to last revision.'))
         self.app.refresh_right()       
     
     def commit(self, action):
@@ -355,7 +356,7 @@
         path = self.selected
 
         if path != None:
-            launch(path)
+            launch.launch(path)
     
     def diff_selected(self, action):
         """ Diff toolbutton -> Selected... """
@@ -363,9 +364,11 @@
     
     def diff_all(self, action):
         """ Diff toolbutton -> All... """
-        from diff import OliveDiff
-        diff = OliveDiff(self.comm)
-        diff.display()
+        wt = WorkingTree.open_containing(self.path)[0]
+        window = DiffWindow(self.app)
+        parent_tree = wt.branch.repository.revision_tree(wt.branch.last_revision())
+        window.set_diff(wt.branch.nick, wt, parent_tree)
+        window.show()
     
     def view_remote(self, action):
         """ Remote context menu -> View contents """

=== modified file 'olive/mkdir.py'
--- olive/mkdir.py	2008-05-05 18:16:46 +0000
+++ olive/mkdir.py	2008-07-17 21:10:05 +0000
@@ -23,75 +23,70 @@
     pass
 
 import gtk
-import gtk.glade
 
 import bzrlib.errors as errors
 
 from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog, warning_dialog
-from guifiles import GLADEFILENAME
-
 from bzrlib.plugins.gtk.errors import show_bzr_error
 
 
-class OliveMkdir:
+class MkdirDialog(gtk.Dialog):
     """ Display the Make directory dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath):
+    
+    def __init__(self, wt, wtpath, parent=None):
         """ Initialize the Make directory dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_mkdir', 'olive-gtk')
-        
-        self.window = self.glade.get_widget('window_mkdir')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_mkdir_mkdir_clicked": self.mkdir,
-                "on_button_mkdir_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
+        gtk.Dialog.__init__(self, title="Olive - Make directory",
+                                  parent=parent,
+                                  flags=0,
+                                  buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+        
+        # Get arguments
         self.wt = wt
         self.wtpath = wtpath
-
-    def display(self):
-        """ Display the Make directory dialog. """
-        self.window.show_all()
+        
+        # Create widgets
+        self._hbox = gtk.HBox()
+        self._label_directory_name = gtk.Label(_i18n("Directory name"))
+        self._entry = gtk.Entry()
+        self._versioned = gtk.CheckButton(_i18n("_Versioned directory"), use_underline=True)
+        self._button_mkdir = gtk.Button(_i18n("_Make directory"), use_underline=True)
+        self._button_mkdir_icon = gtk.Image()
+        self._button_mkdir_icon.set_from_stock(gtk.STOCK_ADD, gtk.ICON_SIZE_BUTTON)
+        self._button_mkdir.set_image(self._button_mkdir_icon)
+        
+        self._entry.connect('activate', self._on_mkdir_clicked)
+        self._button_mkdir.connect('clicked', self._on_mkdir_clicked)
+        
+        # Add widgets to dialog
+        self.vbox.add(self._hbox)
+        self._hbox.add(self._label_directory_name)
+        self._hbox.add(self._entry)
+        self._hbox.set_spacing(5)
+        self.vbox.add(self._versioned)
+        self.action_area.pack_end(self._button_mkdir)
+        
+        self.vbox.show_all()
 
     @show_bzr_error
-    def mkdir(self, widget):
-        # Get the widgets
-        entry = self.glade.get_widget('entry_mkdir')
-        checkbox = self.glade.get_widget('checkbutton_mkdir_versioned')
-        
-        dirname = entry.get_text()
+    def _on_mkdir_clicked(self, widget):
+        dirname = self._entry.get_text()
         
         if dirname == "":
             error_dialog(_i18n('No directory name given'),
                          _i18n('Please specify a desired name for the new directory.'))
             return
         
-        if checkbox.get_active():
-            # Want to create a versioned directory
-            try:
-                os.mkdir(os.path.join(self.wt.basedir, self.wtpath, dirname))
-
+        try:
+            os.mkdir(os.path.join(self.wt.basedir, self.wtpath, dirname))
+            
+            if self._versioned.get_active():
                 self.wt.add([os.path.join(self.wtpath, dirname)])
-            except OSError, e:
-                if e.errno == 17:
-                    error_dialog(_i18n('Directory already exists'),
-                                 _i18n('Please specify another name to continue.'))
-                else:
-                    raise
-        else:
-            # Just a simple directory
-            try:
-                os.mkdir(os.path.join(self.wt.basedir, self.wtpath, dirname))
-            except OSError, e:
-                if e.errno == 17:
-                    error_dialog(_i18n('Directory already exists'),
-                                 _i18n('Please specify another name to continue.'))
-                    return
-
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()
+        except OSError, e:
+            if e.errno == 17:
+                error_dialog(_i18n('Directory already exists'),
+                             _i18n('Please specify another name to continue.'))
+            else:
+                raise
+        
+        self.response(gtk.RESPONSE_OK)

=== modified file 'olive/move.py'
--- olive/move.py	2008-05-05 18:16:46 +0000
+++ olive/move.py	2008-07-17 21:16:27 +0000
@@ -15,7 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import os
-from os.path import dirname
 
 try:
     import pygtk
@@ -24,32 +23,26 @@
     pass
 
 import gtk
-import gtk.glade
 
 import bzrlib.errors as errors
 from bzrlib.workingtree import WorkingTree
 
 from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog
-from errors import show_bzr_error
-from guifiles import GLADEFILENAME
-
-
-class OliveMove:
+from bzrlib.plugins.gtk.errors import show_bzr_error
+
+
+class MoveDialog(gtk.Dialog):
     """ Display the Move dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath, selected=[]):
+    
+    def __init__(self, wt, wtpath, selected, parent=None):
         """ Initialize the Move dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_move', 'olive-gtk')
-        
-        self.window = self.glade.get_widget('window_move')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_move_move_clicked": self.move,
-                "on_button_move_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
+        gtk.Dialog.__init__(self, title="Olive - Move",
+                                  parent=parent,
+                                  flags=0,
+                                  buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+        
+        # Get arguments
         self.wt = wt
         self.wtpath = wtpath
         self.selected = selected
@@ -58,22 +51,48 @@
             self.selected = ""
         
         if self.wtpath == "":
-            directory = dirname(self.wt.abspath(self.selected))
+            directory = os.path.dirname(self.wt.abspath(self.selected))
         else:
-            directory = dirname(self.wt.abspath(self.wtpath + os.sep + self.selected))
-        
-        # Set FileChooser directory
-        self.filechooser = self.glade.get_widget('filechooserbutton_move')
-        self.filechooser.set_filename(directory)
-
-    def display(self):
-        """ Display the Move dialog. """
-        self.window.show_all()
+            directory = os.path.dirname(self.wt.abspath(self.wtpath + os.sep + self.selected))
+        
+        # Create widgets
+        self._hbox = gtk.HBox()
+        self._label_move_to = gtk.Label(_i18n("Move to"))
+        self._filechooser_dialog = gtk.FileChooserDialog(title="Please select a folder",
+                                    parent=self.window,
+                                    action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
+                                    buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
+                                             gtk.STOCK_OPEN, gtk.RESPONSE_OK))
+        self._filechooser_dialog.set_default_response(gtk.RESPONSE_OK)
+        self.filechooser = gtk.FileChooserButton(self._filechooser_dialog)
+        self._button_move = gtk.Button(_i18n("_Move"))
+        self._button_move_icon = gtk.Image()
+        self._button_move_icon.set_from_stock(gtk.STOCK_APPLY, gtk.ICON_SIZE_BUTTON)
+        self._button_move.set_image(self._button_move_icon)
+        
+        self._button_move.connect('clicked', self._on_move_clicked)
+        
+        # Set location
+        self._filechooser_dialog.set_current_folder(directory)
+        
+        # Add widgets to dialog
+        self.vbox.add(self._hbox)
+        self._hbox.add(self._label_move_to)
+        self._hbox.add(self.filechooser)
+        self._hbox.set_spacing(5)
+        self.action_area.pack_end(self._button_move)
+        
+        self.vbox.show_all()
 
     @show_bzr_error
-    def move(self, widget):
+    def _on_move_clicked(self, widget):
         destination = self.filechooser.get_filename()
-
+        
+        if destination == None:
+            error_dialog(_i18n('No folder was selected'),
+                         _i18n('Please select a folder to move the selected file to'))
+            return
+        
         filename = self.selected
             
         if filename is None:
@@ -92,7 +111,5 @@
             return
 
         wt1.move([source], wt1.relpath(destination))
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()
+        
+        self.response(gtk.RESPONSE_OK)

=== modified file 'olive/remove.py'
--- olive/remove.py	2008-05-05 18:16:46 +0000
+++ olive/remove.py	2008-07-17 21:24:16 +0000
@@ -23,76 +23,20 @@
 	pass
 
 import gtk
-import gtk.glade
 
 import bzrlib.errors as errors
 
 from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog, warning_dialog
-from guifiles import GLADEFILENAME
-
-
-class OliveRemove:
-    """ Display the Remove file(s) dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath, selected=[]):
-        """ Initialize the Remove file(s) dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_remove')
-        
-        self.window = self.glade.get_widget('window_remove')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_remove_remove_clicked": self.remove,
-                "on_button_remove_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
-        self.wt = wt
-        self.wtpath = wtpath
-        self.selected = selected
-
-    def display(self):
-        """ Display the Remove file(s) dialog. """
-        self.window.show_all()
-        
-    @show_bzr_error
-    def remove(self, widget):
-        radio_selected = self.glade.get_widget('radiobutton_remove_selected')
-        radio_new = self.glade.get_widget('radiobutton_remove_new')
-        
-        if radio_selected.get_active():
-            # Remove only the selected file
-            filename = self.selected
-            
-            if filename is None:
-                error_dialog(_i18n('No file was selected'),
-                             _i18n('Please select a file from the list,\nor choose the other option.'))
-                return
-            
-            fullpath = self.wt.abspath(os.path.join(self.wtpath, filename))
-            
-            self.wt.remove(fullpath)
-        elif radio_new.get_active():
-            # Remove added files recursively
-            added = self.wt.changes_from(self.wt.basis_tree()).added
-            file_list = sorted([f[0] for f in added], reverse=True)
-            if len(file_list) == 0:
-                warning_dialog(_i18n('No matching files'),
-                               _i18n('No added files were found in the working tree.'))
-                return
-            self.wt.remove(file_list)
-        
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()
-
-class OliveRemoveDialog(gtk.Dialog):
+from bzrlib.plugins.gtk.errors import show_bzr_error
+
+
+class RemoveDialog(gtk.Dialog):
     """ This class wraps the old Remove window into a gtk.Dialog. """
     
-    def __init__(self, wt, wtpath, selected=[], parent=None):
+    def __init__(self, wt, wtpath, selected='', parent=None):
         """ Initialize the Remove file(s) dialog. """
-        gtk.Dialog.__init__(self, title="Remove files - Olive",
+        gtk.Dialog.__init__(self, title="Olive - Remove files",
                                   parent=parent,
                                   flags=0,
                                   buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
@@ -104,19 +48,18 @@
         
         # Create widgets
         self._label = gtk.Label(_i18n("Which file(s) do you want to remove?"))
-        self._radio_selected = gtk.RadioButton(None, _i18n("Selected only"), False)
+        self._radio_selected = gtk.RadioButton(None, _i18n("Selected: %s"%self.selected), False)
         self._radio_added = gtk.RadioButton(self._radio_selected, _i18n("All files with status 'added'"), False)
-        self._button_remove = gtk.Button(_i18n("_Remove"), use_underline=True)
+        self._button_remove = gtk.Button(stock=gtk.STOCK_REMOVE)
         
         self._button_remove.connect('clicked', self._on_remove_clicked)
         
-        self.vbox.pack_start(self._label)
-        self.vbox.pack_end(self._radio_added)
-        self.vbox.pack_end(self._radio_selected)
-        
+        self.vbox.add(self._label)
+        self.vbox.add(self._radio_selected)
+        self.vbox.add(self._radio_added)
+        self.vbox.set_spacing(3)
         self.action_area.pack_end(self._button_remove)
         
-        self.vbox.set_spacing(3)
         self.vbox.show_all()
         
     @show_bzr_error

=== modified file 'olive/rename.py'
--- olive/rename.py	2008-05-05 18:16:46 +0000
+++ olive/rename.py	2008-07-18 10:39:25 +0000
@@ -23,49 +23,60 @@
     pass
 
 import gtk
-import gtk.glade
 
 import bzrlib.errors as errors
 from bzrlib.workingtree import WorkingTree
 
-from errors import show_bzr_error
+from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog
-from guifiles import GLADEFILENAME
-from bzrlib.plugins.gtk import _i18n
-
-
-class OliveRename:
+from bzrlib.plugins.gtk.errors import show_bzr_error
+
+
+class RenameDialog(gtk.Dialog):
     """ Display the Rename dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath, selected=[]):
-        """ Initialize the Rename dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_rename')
-        
-        self.window = self.glade.get_widget('window_rename')
-        self.entry = self.glade.get_widget('entry_rename')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_rename_rename_clicked": self.rename,
-                "on_button_rename_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
+    
+    def __init__(self, wt, wtpath, selected=None, parent=None):
+        """ Initialize the Rename file dialog. """
+        gtk.Dialog.__init__(self, title="Olive - Rename files",
+                                  parent=parent,
+                                  flags=0,
+                                  buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+        
+        # Get arguments
         self.wt = wt
         self.wtpath = wtpath
         self.selected = selected
         
-    def display(self):
-        """ Display the Rename dialog. """
+        # Create widgets
+        self._hbox = gtk.HBox()
+        self._label_rename_to = gtk.Label(_i18n("Rename to"))
+        self._entry = gtk.Entry()
+        self._button_rename = gtk.Button(_i18n("_Rename"))
+        self._button_rename_icon = gtk.Image()
+        self._button_rename_icon.set_from_stock(gtk.STOCK_APPLY, gtk.ICON_SIZE_BUTTON)
+        self._button_rename.set_image(self._button_rename_icon)
+        
+        self._entry.connect('activate', self._on_rename_clicked)
+        self._button_rename.connect('clicked', self._on_rename_clicked)
+        
+        # Set text
         if self.selected is not None:
-            self.entry.set_text(self.selected)
-        
-        self.window.show_all()
-
+            self._entry.set_text(self.selected)
+        
+        # Add widgets to dialog
+        self.vbox.add(self._hbox)
+        self._hbox.add(self._label_rename_to)
+        self._hbox.add(self._entry)
+        self._hbox.set_spacing(5)
+        self.action_area.pack_end(self._button_rename)
+        
+        self.vbox.show_all()
+        
     @show_bzr_error
-    def rename(self, widget):
+    def _on_rename_clicked(self, widget):
         # Get entry
         old_filename = self.selected
-        new_filename = self.entry.get_text()
+        new_filename = self._entry.get_text()
             
         if old_filename is None:
             error_dialog(_i18n('No file was selected'),
@@ -89,7 +100,5 @@
                          _i18n('The destination is not in the same branch.'))
             return
         wt1.rename_one(source, destination)
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()
+        
+        self.response(gtk.RESPONSE_OK)

=== added file 'olive/window.py'
--- olive/window.py	1970-01-01 00:00:00 +0000
+++ olive/window.py	2008-07-25 19:54:31 +0000
@@ -0,0 +1,454 @@
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
+# Some parts of the code are:
+# Copyright (C) 2005, 2006 by Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+import gtk
+import gobject
+
+from bzrlib.plugins.gtk import _i18n, icon_path
+
+
+class OliveGui(gtk.Window):
+    """ Olive main window """
+    
+    def __init__(self, calling_app):
+        # Pointer to calling instance for signal connection
+        self.signal = calling_app
+        
+        # Initialise window
+        gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
+        self.set_title(_i18n("Olive - Bazaar GUI"))
+        self.set_icon_list(gtk.gdk.pixbuf_new_from_file(icon_path("oliveicon2.png")),
+                           gtk.gdk.pixbuf_new_from_file(icon_path("olive-gtk.png")),
+                           # Who has the svg version of the icon? Would be nice to include
+                           #gtk.gdk.pixbuf_new_from_file(icon_path("olive.svg"))
+                           )
+        self.set_property("width-request", 700)
+        self.set_property("height-request", 400)
+        
+        self.connect("destroy", self.destroy)
+        self.connect("delete_event", self.signal.on_window_main_delete_event)
+        
+        # Accelerator group to Quit program
+        accelgroup = gtk.AccelGroup()
+        self.add_accel_group(accelgroup)
+        self.quit_action = gtk.Action(_i18n("Quit"), None, None, gtk.STOCK_QUIT)
+        self.quit_action.connect('activate', self.signal.on_window_main_delete_event)
+        actiongroup = gtk.ActionGroup('QuitAction')
+        actiongroup.add_action_with_accel(self.quit_action, None)
+        self.quit_action.set_accel_group(accelgroup)
+        self.quit_action.connect_accelerator()
+        
+        # High level build up of window
+        self.vbox = gtk.VBox(False, 0)
+        self.add(self.vbox)
+        
+        # Menu bar
+        self._create_menubar()
+        self.vbox.pack_start(self.mb, False, False, 0)
+        
+        # Toolbar
+        self._create_toolbar()
+        self.vbox.pack_start(self.tb, False, False, 0)
+        
+        # Locationbar
+        self._create_locationbar()
+        self.vbox.pack_start(self.locationbar, False, False, 0)
+        
+        # Main area
+        self.hpaned_main = gtk.HPaned()
+        self._create_bookmarklist()
+        self.hpaned_main.add(self.scrolledwindow_left)
+        self._create_filelist()
+        self.hpaned_main.add(self.scrolledwindow_right)
+        self.vbox.pack_start(self.hpaned_main, True, True, 0)
+        
+        # Statusbar
+        self.statusbar = gtk.Statusbar()
+        self.vbox.pack_end(self.statusbar, False, False, 0)
+    
+    def show(self):
+        self.show_all()        
+    
+    def destroy(self, widget=None, data=None):
+        """ Ends the program """
+        gtk.main_quit()
+
+    def _create_menubar(self):
+        self.mb = gtk.MenuBar()
+        
+        # File menu
+        self.mb_file = gtk.MenuItem(_i18n("_File"))
+        self.mb_file_menu = gtk.Menu()
+        
+        self.mb_file_add = gtk.ImageMenuItem(gtk.STOCK_ADD, _i18n("_Add file(s)"))
+        self.mb_file_add.connect('activate', self.signal.on_menuitem_add_files_activate)
+        self.mb_file_menu.append(self.mb_file_add)
+        
+        self.mb_file_remove = gtk.ImageMenuItem(gtk.STOCK_REMOVE, _i18n("_Remove file(s)"))
+        self.mb_file_remove.connect('activate', self.signal.on_menuitem_remove_file_activate)
+        self.mb_file_menu.append(self.mb_file_remove)
+        
+        self.mb_file_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_file_bookmark = gtk.MenuItem(_i18n("_Bookmark current directory"))
+        self.mb_file_bookmark.connect('activate', self.signal.on_menuitem_file_bookmark_activate)
+        self.mb_file_menu.append(self.mb_file_bookmark)
+        
+        self.mb_file_mkdir = gtk.MenuItem(_i18n("_Make directory"))
+        self.mb_file_mkdir.connect('activate', self.signal.on_menuitem_file_make_directory_activate)
+        self.mb_file_menu.append(self.mb_file_mkdir)
+        
+        self.mb_file_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_file_rename = gtk.MenuItem(_i18n("_Rename"))
+        self.mb_file_rename.connect('activate', self.signal.on_menuitem_file_rename_activate)
+        self.mb_file_menu.append(self.mb_file_rename)
+        
+        self.mb_file_move = gtk.MenuItem(_i18n("_Move"))
+        self.mb_file_move.connect('activate', self.signal.on_menuitem_file_move_activate)
+        self.mb_file_menu.append(self.mb_file_move)
+        
+        self.mb_file_annotate = gtk.MenuItem(_i18n("_Annotate"))
+        self.mb_file_annotate.connect('activate', self.signal.on_menuitem_file_annotate_activate)
+        self.mb_file_menu.append(self.mb_file_annotate)
+        
+        self.mb_file_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_file_quit = self.quit_action.create_menu_item()
+        self.mb_file_menu.append(self.mb_file_quit)
+        
+        self.mb_file.set_submenu(self.mb_file_menu)
+        self.mb.append(self.mb_file)
+        
+        # View menu
+        self.mb_view = gtk.MenuItem(_i18n("_View"))
+        self.mb_view_menu = gtk.Menu()
+        
+        self.mb_view_showhidden = gtk.CheckMenuItem(_i18n("Show _hidden files"))
+        self.mb_view_showhidden.connect('activate', self.signal.on_menuitem_view_show_hidden_files_activate)
+        self.mb_view_menu.append(self.mb_view_showhidden)
+        
+        self.mb_view_showignored = gtk.CheckMenuItem(_i18n("Show _ignored files"))
+        self.mb_view_showignored.connect('activate', self.signal.on_menuitem_view_show_ignored_files_activate)
+        self.mb_view_menu.append(self.mb_view_showignored)
+        
+        self.mb_view_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_view_refresh = gtk.ImageMenuItem(gtk.STOCK_REFRESH, _i18n("_Refresh"))
+        self.mb_view_refresh.connect('activate', self.signal.on_menuitem_view_refresh_activate)
+        self.mb_view_menu.append(self.mb_view_refresh)
+        
+        self.mb_view.set_submenu(self.mb_view_menu)
+        self.mb.append(self.mb_view)
+        
+        # Branch menu
+        self.mb_branch = gtk.MenuItem(_i18n("_Branch"))
+        self.mb_branch_menu = gtk.Menu()
+        
+        self.mb_branch_initialize = gtk.MenuItem(_i18n("_Initialize"))
+        self.mb_branch_initialize.connect('activate', self.signal.on_menuitem_branch_initialize_activate)
+        self.mb_branch_menu.append(self.mb_branch_initialize)
+        
+        self.mb_branch_get = gtk.MenuItem(_i18n("_Get"))
+        self.mb_branch_get.connect('activate', self.signal.on_menuitem_branch_get_activate)
+        self.mb_branch_menu.append(self.mb_branch_get)
+        
+        self.mb_branch_checkout = gtk.MenuItem(_i18n("C_heckout"))
+        self.mb_branch_checkout.connect('activate', self.signal.on_menuitem_branch_checkout_activate)
+        self.mb_branch_menu.append(self.mb_branch_checkout)
+        
+        self.mb_branch_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_branch_pull = gtk.ImageMenuItem(_i18n("Pu_ll"))
+        pullimage = gtk.Image()
+        pullimage.set_from_file(icon_path("pull16.png"))
+        self.mb_branch_pull.set_image(pullimage)
+        self.mb_branch_pull.connect('activate', self.signal.on_menuitem_branch_pull_activate)
+        self.mb_branch_menu.append(self.mb_branch_pull)
+        
+        self.mb_branch_push = gtk.ImageMenuItem(_i18n("Pu_sh"))
+        pushimage = gtk.Image()
+        pushimage.set_from_file(icon_path("push16.png"))
+        self.mb_branch_push.set_image(pushimage)
+        self.mb_branch_push.connect('activate', self.signal.on_menuitem_branch_push_activate)
+        self.mb_branch_menu.append(self.mb_branch_push)
+        
+        self.mb_branch_update = gtk.MenuItem(_i18n("_Update"))
+        self.mb_branch_update.connect('activate', self.signal.on_menuitem_branch_update_activate)
+        self.mb_branch_menu.append(self.mb_branch_update)
+        
+        self.mb_branch_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_branch_revert = gtk.ImageMenuItem(_i18n("_Revert all changes"))
+        revertimage = gtk.Image()
+        revertimage.set_from_stock(gtk.STOCK_REVERT_TO_SAVED, gtk.ICON_SIZE_MENU)
+        self.mb_branch_revert.set_image(revertimage)
+        self.mb_branch_revert.connect('activate', self.signal.on_menuitem_branch_revert_activate)
+        self.mb_branch_menu.append(self.mb_branch_revert)
+        
+        self.mb_branch_merge = gtk.MenuItem(_i18n("_Merge"))
+        self.mb_branch_merge.connect('activate', self.signal.on_menuitem_branch_merge_activate)
+        self.mb_branch_menu.append(self.mb_branch_merge)
+        
+        self.mb_branch_commit = gtk.ImageMenuItem(_i18n("_Commit"))
+        commitimage = gtk.Image()
+        commitimage.set_from_file(icon_path("commit16.png"))
+        self.mb_branch_commit.set_image(commitimage)
+        self.mb_branch_commit.connect('activate', self.signal.on_menuitem_branch_commit_activate)
+        self.mb_branch_menu.append(self.mb_branch_commit)
+        
+        self.mb_branch_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_branch_tags = gtk.ImageMenuItem(_i18n("Ta_gs"))
+        tagsimage = gtk.Image()
+        tagsimage.set_from_file(icon_path("tag-16.png"))
+        self.mb_branch_tags.set_image(tagsimage)
+        self.mb_branch_tags.connect('activate', self.signal.on_menuitem_branch_tags_activate)
+        self.mb_branch_menu.append(self.mb_branch_tags)
+        
+        self.mb_branch_status = gtk.MenuItem(_i18n("S_tatus"))
+        self.mb_branch_status.connect('activate', self.signal.on_menuitem_branch_status_activate)
+        self.mb_branch_menu.append(self.mb_branch_status)
+        
+        self.mb_branch_missingrevisions = gtk.MenuItem(_i18n("Missing _revisions"))
+        self.mb_branch_missingrevisions.connect('activate', self.signal.on_menuitem_branch_missing_revisions_activate)
+        self.mb_branch_menu.append(self.mb_branch_missingrevisions)
+        
+        self.mb_branch_conflicts = gtk.MenuItem(_i18n("Con_flicts"))
+        self.mb_branch_conflicts.connect('activate', self.signal.on_menuitem_branch_conflicts_activate)
+        self.mb_branch_menu.append(self.mb_branch_conflicts)
+        
+        self.mb_branch.set_submenu(self.mb_branch_menu)
+        self.mb.append(self.mb_branch)
+        
+        # Statistics menu
+        self.mb_statistics = gtk.MenuItem(_i18n("_Statistics"))
+        self.mb_statistics_menu = gtk.Menu()
+        
+        self.mb_statistics_differences = gtk.ImageMenuItem(_i18n("_Differences"))
+        diffimage = gtk.Image()
+        diffimage.set_from_file(icon_path("diff16.png"))
+        self.mb_statistics_differences.set_image(diffimage)
+        self.mb_statistics_differences.connect('activate', self.signal.on_menuitem_stats_diff_activate)
+        self.mb_statistics_menu.append(self.mb_statistics_differences)
+        
+        self.mb_statistics_log = gtk.ImageMenuItem(_i18n("_Log"))
+        logimage = gtk.Image()
+        logimage.set_from_file(icon_path("log16.png"))
+        self.mb_statistics_log.set_image(logimage)
+        self.mb_statistics_log.connect('activate', self.signal.on_menuitem_stats_log_activate)
+        self.mb_statistics_menu.append(self.mb_statistics_log)
+        
+        self.mb_statistics_information = gtk.MenuItem(_i18n("_Information"))
+        self.mb_statistics_information.connect('activate', self.signal.on_menuitem_stats_infos_activate)
+        self.mb_statistics_menu.append(self.mb_statistics_information)
+        
+        self.mb_statistics.set_submenu(self.mb_statistics_menu)
+        self.mb.append(self.mb_statistics)
+        
+        # Help menu
+        self.mb_help = gtk.MenuItem(_i18n("Help"))
+        self.mb_help_menu = gtk.Menu()
+        
+        self.mb_help_about = gtk.ImageMenuItem(gtk.STOCK_ABOUT)
+        self.mb_help_about.connect('activate', self.signal.on_about_activate)
+        self.mb_help_menu.append(self.mb_help_about)
+        
+        self.mb_help.set_submenu(self.mb_help_menu)
+        self.mb.append(self.mb_help)
+    
+    def _create_toolbar(self):
+        self.tb = gtk.Toolbar()
+        
+        self.tb_refresh_icon = gtk.Image()
+        self.tb_refresh_icon.set_from_file(icon_path("refresh.png"))
+        self.tb_refresh = gtk.ToolButton(self.tb_refresh_icon, _i18n("Refresh"))
+        self.tb_refresh.connect('clicked', self.signal.on_menuitem_view_refresh_activate)
+        self.tb.add(self.tb_refresh)
+        
+        self.tb_diff_icon = gtk.Image()
+        self.tb_diff_icon.set_from_file(icon_path("diff.png"))
+        self.tb_diff = gtk.ToolButton(self.tb_diff_icon, _i18n("Diff"))
+        self.tb_diff.connect('clicked', self.signal.on_menuitem_stats_diff_activate)
+        self.tb.add(self.tb_diff)
+        
+        self.tb_log_icon = gtk.Image()
+        self.tb_log_icon.set_from_file(icon_path("log.png"))
+        self.tb_log = gtk.ToolButton(self.tb_log_icon, _i18n("Log"))
+        self.tb_log.connect('clicked', self.signal.on_menuitem_stats_log_activate)
+        self.tb.add(self.tb_log)
+        
+        self.tb.add(gtk.SeparatorToolItem())
+        
+        self.tb_commit_icon = gtk.Image()
+        self.tb_commit_icon.set_from_file(icon_path("commit.png"))
+        self.tb_commit = gtk.ToolButton(self.tb_commit_icon, _i18n("Commit"))
+        self.tb_commit.connect('clicked', self.signal.on_menuitem_branch_commit_activate)
+        self.tb.add(self.tb_commit)
+        
+        self.tb.add(gtk.SeparatorToolItem())
+        
+        self.tb_pull_icon = gtk.Image()
+        self.tb_pull_icon.set_from_file(icon_path("pull.png"))
+        self.tb_pull = gtk.ToolButton(self.tb_pull_icon, _i18n("Pull"))
+        self.tb_pull.connect('clicked', self.signal.on_menuitem_branch_pull_activate)
+        self.tb.add(self.tb_pull)
+        
+        self.tb_push_icon = gtk.Image()
+        self.tb_push_icon.set_from_file(icon_path("push.png"))
+        self.tb_push = gtk.ToolButton(self.tb_push_icon, _i18n("Push"))
+        self.tb_push.connect('clicked', self.signal.on_menuitem_branch_push_activate)
+        self.tb.add(self.tb_push)
+        
+        self.tb_update_icon = gtk.Image()
+        self.tb_update_icon.set_from_file(icon_path("pull.png"))
+        self.tb_update = gtk.ToolButton(self.tb_update_icon, _i18n("Update"))
+        self.tb_update.connect('clicked', self.signal.on_menuitem_branch_update_activate)
+        self.tb.add(self.tb_update)
+    
+    def _create_locationbar(self):
+        """ Creates the location bar, including the history widgets """
+        self.locationbar = gtk.HBox()
+        
+        self.button_location_up = gtk.Button()
+        self.button_location_up.set_relief(gtk.RELIEF_NONE)
+        image_location_up = gtk.Image()
+        image_location_up.set_from_stock(gtk.STOCK_GO_UP, gtk.ICON_SIZE_BUTTON)
+        self.button_location_up.add(image_location_up)
+        self.button_location_up.connect("clicked", self.signal.on_button_location_up_clicked)
+        self.locationbar.pack_start(self.button_location_up, False, False, 0)
+        
+        self.entry_location = gtk.Entry()
+        self.entry_location.connect("activate", self.signal.on_button_location_jump_clicked)
+        self.locationbar.pack_start(self.entry_location, True, True, 0)
+        
+        self.image_location_error = gtk.Image()
+        self.image_location_error.set_from_stock(gtk.STOCK_DIALOG_ERROR, gtk.ICON_SIZE_BUTTON)
+        self.locationbar.pack_start(self.image_location_error, False, False, 0)
+        
+        self.button_location_jump = gtk.Button(stock=gtk.STOCK_JUMP_TO)
+        self.button_location_jump.set_relief(gtk.RELIEF_NONE)
+        self.button_location_jump.connect("clicked", self.signal.on_button_location_jump_clicked)
+        self.locationbar.pack_start(self.button_location_jump, False, False, 0)
+        
+        self.locationbar.pack_start(gtk.VSeparator(), False, False, 0)
+        
+        self.checkbutton_history = gtk.CheckButton(_i18n("H_istory Mode"))
+        self.checkbutton_history.connect("toggled", self.signal.on_checkbutton_history_toggled)
+        self.locationbar.pack_start(self.checkbutton_history, False, False, 0)
+        
+        self.entry_history_revno = gtk.Entry()
+        self.entry_history_revno.set_property("width-request", 75)
+        self.entry_history_revno.set_sensitive(False)
+        self.entry_history_revno.connect("activate", self.signal.on_entry_history_revno_activate)
+        self.locationbar.pack_start(self.entry_history_revno, False, False, 0)
+        
+        self.button_history_browse = gtk.Button()
+        self.button_history_browse.set_sensitive(False)
+        self.image_history_browse = gtk.Image()
+        self.image_history_browse.set_from_stock(gtk.STOCK_OPEN, gtk.ICON_SIZE_BUTTON)
+        self.button_history_browse.add(self.image_history_browse)
+        self.button_history_browse.connect("clicked", self.signal.on_button_history_browse_clicked)
+        self.locationbar.pack_start(self.button_history_browse, False, False, 0)
+    
+    def _create_bookmarklist(self):
+        """ Creates the bookmark list (a ListStore in a TreeView in a ScrolledWindow)"""
+        self.scrolledwindow_left = gtk.ScrolledWindow()
+        self.scrolledwindow_left.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        
+        self.treeview_left = gtk.TreeView()
+        self.treeview_left.set_headers_visible(False)
+        self.treeview_left.connect("button-press-event", self.signal.on_treeview_left_button_press_event)
+        self.treeview_left.connect("row-activated", self.signal.on_treeview_left_row_activated)
+        self.scrolledwindow_left.add(self.treeview_left)
+
+        # Move olive/__init__.py _load_left List creation here
+            
+    def _create_filelist(self):
+        """ Creates the file list (a ListStore in a TreeView in a ScrolledWindow)"""
+        # Model: [ icon, dir, name, status text, status, size (int), size (human), mtime (int), mtime (local), fileid ]
+        self.scrolledwindow_right = gtk.ScrolledWindow()
+        self.scrolledwindow_right.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        
+        self.treeview_right = gtk.TreeView()
+        self.treeview_right.connect("button-press-event", self.signal.on_treeview_right_button_press_event)
+        self.treeview_right.connect("row-activated", self.signal.on_treeview_right_row_activated)
+        self.scrolledwindow_right.add(self.treeview_right)
+
+        # Move olive/__init__.py _load_right List creation here
+    
+    def set_view_to_localbranch(self, notbranch=False):
+        """ Change the sensitivity of gui items to reflect the fact that the path is a branch or not"""
+        self.mb_branch_initialize.set_sensitive(notbranch)
+        self.mb_branch_get.set_sensitive(notbranch)
+        self.mb_branch_checkout.set_sensitive(notbranch)
+        self.mb_branch_pull.set_sensitive(not notbranch)
+        self.mb_branch_push.set_sensitive(not notbranch)
+        self.mb_branch_update.set_sensitive(not notbranch)
+        self.mb_branch_revert.set_sensitive(not notbranch)
+        self.mb_branch_merge.set_sensitive(not notbranch)
+        self.mb_branch_commit.set_sensitive(not notbranch)
+        self.mb_branch_tags.set_sensitive(not notbranch)
+        self.mb_branch_status.set_sensitive(not notbranch)
+        self.mb_branch_missingrevisions.set_sensitive(not notbranch)
+        self.mb_branch_conflicts.set_sensitive(not notbranch)
+        self.mb_statistics.set_sensitive(not notbranch)
+        self.mb_statistics_differences.set_sensitive(not notbranch)
+        self.mb_file_add.set_sensitive(not notbranch)
+        self.mb_file_remove.set_sensitive(not notbranch)
+        self.mb_file_mkdir.set_sensitive(not notbranch)
+        self.mb_file_rename.set_sensitive(not notbranch)
+        self.mb_file_move.set_sensitive(not notbranch)
+        self.mb_file_annotate.set_sensitive(not notbranch)
+        self.tb_diff.set_sensitive(not notbranch)
+        self.tb_log.set_sensitive(not notbranch)
+        self.tb_commit.set_sensitive(not notbranch)
+        self.tb_pull.set_sensitive(not notbranch)
+        self.tb_push.set_sensitive(not notbranch)
+        self.tb_update.set_sensitive(not notbranch)
+    
+    def set_view_to_remotebranch(self):
+        """ Change the sensitivity of gui items to reflect the fact that the branch is remote"""
+        self.mb_file_add.set_sensitive(False)
+        self.mb_file_remove.set_sensitive(False)
+        self.mb_file_mkdir.set_sensitive(False)
+        self.mb_file_rename.set_sensitive(False)
+        self.mb_file_move.set_sensitive(False)
+        self.mb_file_annotate.set_sensitive(False)
+        self.mb_branch_initialize.set_sensitive(False)
+        self.mb_branch_get.set_sensitive(True)
+        self.mb_branch_checkout.set_sensitive(True)
+        self.mb_branch_pull.set_sensitive(False)
+        self.mb_branch_push.set_sensitive(False)
+        self.mb_branch_update.set_sensitive(False)
+        self.mb_branch_revert.set_sensitive(False)
+        self.mb_branch_merge.set_sensitive(False)
+        self.mb_branch_commit.set_sensitive(False)
+        self.mb_branch_tags.set_sensitive(True)
+        self.mb_branch_status.set_sensitive(False)
+        self.mb_branch_missingrevisions.set_sensitive(False)
+        self.mb_branch_conflicts.set_sensitive(False)
+        self.mb_statistics.set_sensitive(True)
+        self.mb_statistics_differences.set_sensitive(False)
+        self.tb_diff.set_sensitive(False)
+        self.tb_log.set_sensitive(True)
+        self.tb_commit.set_sensitive(False)
+        self.tb_pull.set_sensitive(False)
+        self.tb_push.set_sensitive(False)
+        self.tb_update.set_sensitive(False)

=== modified file 'preferences/plugins.py'
--- preferences/plugins.py	2008-04-02 13:36:55 +0000
+++ preferences/plugins.py	2008-07-21 13:50:35 +0000
@@ -67,7 +67,7 @@
 
     def row_selected(self, tv, path, tvc):
         import bzrlib
-        p = bzrlib.plugin.plugins()[self.model[path][0]]
+        p = bzrlib.plugin.plugins()[self.model[path][0]].module
         from inspect import getdoc
 
         for w in self.table.get_children():

=== modified file 'push.py'
--- push.py	2008-05-05 18:16:46 +0000
+++ push.py	2008-07-22 19:46:47 +0000
@@ -94,12 +94,7 @@
         """ Push button clicked handler. """
         location = self._combo.get_child().get_text()
         revs = 0
-        if self.branch is not None and self.branch.get_push_location() is None:
-            response = question_dialog(_i18n('Set default push location'),
-                                       _i18n('There is no default push location set.\nSet %r as default now?') % location)
-            if response == gtk.RESPONSE_OK:
-                self.branch.set_push_location(location)
-
+        
         try:
             revs = do_push(self.branch, location=location, overwrite=False)
         except errors.DivergedBranches:
@@ -108,6 +103,9 @@
             if response == gtk.RESPONSE_YES:
                 revs = do_push(self.branch, location=location, overwrite=True)
         
+        if self.branch is not None and self.branch.get_push_location() is None:
+            self.branch.set_push_location(location)
+        
         self._history.add_entry(location)
         info_dialog(_i18n('Push successful'),
                     _i18n("%d revision(s) pushed.") % revs)

=== modified file 'revisionmenu.py'
--- revisionmenu.py	2008-01-23 16:36:21 +0000
+++ revisionmenu.py	2008-07-01 21:54:21 +0000
@@ -27,7 +27,7 @@
 from bzrlib import (errors, ui)
 from bzrlib.revision import NULL_REVISION
 
-class RevisionPopupMenu(gtk.Menu):
+class RevisionMenu(gtk.Menu):
 
     __gsignals__ = {
             'tag-added': (
@@ -37,11 +37,18 @@
             )
     }
 
-    def __init__(self, repository, revids, branch=None, wt=None):
-        super(RevisionPopupMenu, self).__init__()
+    def __init__(self, repository, revids, branch=None, wt=None, parent=None):
+        super(RevisionMenu, self).__init__()
+        self._parent = parent
         self.branch = branch
         self.repository = repository
         self.wt = wt
+        self.set_revision_ids(revids)
+
+    def set_revision_ids(self, revids):
+        assert isinstance(revids, list)
+        for c in self.get_children():
+            self.remove(c)
         self.revids = revids
         self.create_items()
 
@@ -50,44 +57,55 @@
             item = gtk.MenuItem("View _Changes")
             item.connect('activate', self.show_diff)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Push")
             item.connect('activate', self.show_push)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Tag Revision")
             item.connect('activate', self.show_tag)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Merge Directive")
             item.connect('activate', self.store_merge_directive)
             # FIXME: self.append(item)
-            self.show_all()
+
+            item = gtk.MenuItem("_Send Merge Directive")
+            item.connect('activate', self.send_merge_directive)
+            self.append(item)
             
             if self.wt:
                 item = gtk.MenuItem("_Revert to this revision")
                 item.connect('activate', self.revert)
                 self.append(item)
-                self.show_all()
+
+        self.show_all()
 
     def store_merge_directive(self, item):
         from bzrlib.plugins.gtk.mergedirective import CreateMergeDirectiveDialog
         window = CreateMergeDirectiveDialog(self.branch, self.revids[0])
         window.show()
 
+    def send_merge_directive(self, item):
+        from bzrlib.plugins.gtk.mergedirective import SendMergeDirectiveDialog
+        from cStringIO import StringIO
+        window = SendMergeDirectiveDialog(self.branch, self.revids[0])
+        if window.run() == gtk.RESPONSE_OK:
+            outf = StringIO()
+            outf.writelines(window.get_merge_directive().to_lines())
+            mail_client = self.branch.get_config().get_mail_client()
+            mail_client.compose_merge_request(window.get_mail_to(), "[MERGE]",
+                                              outf.getvalue())
+        window.destroy()
+
     def show_diff(self, item):
         from bzrlib.plugins.gtk.diff import DiffWindow
-        window = DiffWindow(parent=self.parent)
-        parentids = self.repository.revision_parents(self.revids[0])
-
+        window = DiffWindow(parent=self._parent)
+        parentids = self.repository.get_revision(self.revids[0]).parent_ids
         if len(parentids) == 0:
             parentid = NULL_REVISION
         else:
             parentid = parentids[0]
-
         rev_tree    = self.repository.revision_tree(self.revids[0])
         parent_tree = self.repository.revision_tree(parentid)
         window.set_diff(self.revids[0], rev_tree, parent_tree)

=== modified file 'revisionview.py'
--- revisionview.py	2008-06-24 10:34:38 +0000
+++ revisionview.py	2008-07-11 15:46:32 +0000
@@ -22,9 +22,11 @@
 import gobject
 import webbrowser
 
-from bzrlib.plugins.gtk import icon_path
 from bzrlib.osutils import format_date
 from bzrlib.util.bencode import bdecode
+from bzrlib.testament import Testament
+
+from bzrlib.plugins.gtk import icon_path
 
 try:
     from bzrlib.plugins.gtk import seahorse
@@ -220,7 +222,17 @@
                                         "This revision has not been signed.")
 
     def show_signature(self, crypttext):
-        key = seahorse.verify(crypttext)
+        (cleartext, key) = seahorse.verify(crypttext)
+
+        assert cleartext is not None
+
+        inv = self.repository.get_inventory(self.revision.revision_id)
+        expected_testament = Testament(self.revision, inv).as_short_text()
+        if expected_testament != cleartext:
+            self.signature_image.set_from_file(icon_path("sign-bad.png"))
+            self.signature_label.set_markup("<b>Signature does not match repository data</b>\n" +
+                        "The signature plaintext is different from the expected testament plaintext.")
+            return
 
         if key and key.is_available():
             if key.is_trusted():
@@ -322,8 +334,8 @@
         self._create_general()
         self._create_relations()
         # Disabled because testaments aren't verified yet:
-        # if has_seahorse:
-        #    self._create_signature()
+        if has_seahorse:
+            self._create_signature()
         self._create_file_info_view()
         self._create_bugs()
 
@@ -497,7 +509,7 @@
         table.resize(max(len(revids), 1), 2)
 
         for idx, revid in enumerate(revids):
-            align = gtk.Alignment(0.0, 0.0)
+            align = gtk.Alignment(0.0, 0.0, 1, 1)
             widgets.append(align)
             table.attach(align, 1, 2, idx, idx + 1,
                                       gtk.EXPAND | gtk.FILL, gtk.FILL)
@@ -520,12 +532,16 @@
                 hbox.pack_start(button, expand=False, fill=True)
                 button.show()
 
-            button = gtk.Button(revid)
+            button = gtk.Button()
+            revid_label = gtk.Label(str(revid))
+            revid_label.set_ellipsize(pango.ELLIPSIZE_MIDDLE)
+            revid_label.set_alignment(0.0, 0.5)
+            button.add(revid_label)
             button.connect("clicked",
                     lambda w, r: self.set_revision(self._repository.get_revision(r)), revid)
             button.set_use_underline(False)
-            hbox.pack_start(button, expand=False, fill=True)
-            button.show()
+            hbox.pack_start(button, expand=True, fill=True)
+            button.show_all()
 
     def _create_general(self):
         vbox = gtk.VBox(False, 6)
@@ -554,102 +570,91 @@
         self.table.set_col_spacings(6)
         self.table.show()
 
-        align = gtk.Alignment(1.0, 0.5)
+        row = 0
+
         label = gtk.Label()
+        label.set_alignment(1.0, 0.5)
         label.set_markup("<b>Revision Id:</b>")
-        align.add(label)
-        self.table.attach(align, 0, 1, 0, 1, gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         label.show()
 
-        align = gtk.Alignment(0.0, 0.5)
         revision_id = gtk.Label()
+        revision_id.set_ellipsize(pango.ELLIPSIZE_MIDDLE)
+        revision_id.set_alignment(0.0, 0.5)
         revision_id.set_selectable(True)
         self.connect('notify::revision', 
                 lambda w, p: revision_id.set_text(self._revision.revision_id))
-        align.add(revision_id)
-        self.table.attach(align, 1, 2, 0, 1, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(revision_id, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
         revision_id.show()
 
-        align = gtk.Alignment(1.0, 0.5)
+        row += 1
         self.author_label = gtk.Label()
+        self.author_label.set_alignment(1.0, 0.5)
         self.author_label.set_markup("<b>Author:</b>")
-        align.add(self.author_label)
-        self.table.attach(align, 0, 1, 1, 2, gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(self.author_label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         self.author_label.show()
 
-        align = gtk.Alignment(0.0, 0.5)
         self.author = gtk.Label()
+        self.author.set_ellipsize(pango.ELLIPSIZE_END)
+        self.author.set_alignment(0.0, 0.5)
         self.author.set_selectable(True)
-        align.add(self.author)
-        self.table.attach(align, 1, 2, 1, 2, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(self.author, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
         self.author.show()
         self.author.hide()
 
-        align = gtk.Alignment(1.0, 0.5)
+        row += 1
         label = gtk.Label()
+        label.set_alignment(1.0, 0.5)
         label.set_markup("<b>Committer:</b>")
-        align.add(label)
-        self.table.attach(align, 0, 1, 2, 3, gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         label.show()
 
-        align = gtk.Alignment(0.0, 0.5)
         self.committer = gtk.Label()
+        self.committer.set_ellipsize(pango.ELLIPSIZE_END)
+        self.committer.set_alignment(0.0, 0.5)
         self.committer.set_selectable(True)
-        align.add(self.committer)
-        self.table.attach(align, 1, 2, 2, 3, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(self.committer, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
         self.committer.show()
 
-        align = gtk.Alignment(0.0, 0.5)
+        row += 1
         label = gtk.Label()
+        label.set_alignment(1.0, 0.5)
         label.set_markup("<b>Branch nick:</b>")
-        align.add(label)
-        self.table.attach(align, 0, 1, 3, 4, gtk.FILL, gtk.FILL)
+        self.table.attach(label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         label.show()
-        align.show()
 
-        align = gtk.Alignment(0.0, 0.5)
         self.branchnick_label = gtk.Label()
+        self.branchnick_label.set_ellipsize(pango.ELLIPSIZE_MIDDLE)
+        self.branchnick_label.set_alignment(0.0, 0.5)
         self.branchnick_label.set_selectable(True)
-        align.add(self.branchnick_label)
-        self.table.attach(align, 1, 2, 3, 4, gtk.EXPAND | gtk.FILL, gtk.FILL)
+        self.table.attach(self.branchnick_label, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
         self.branchnick_label.show()
-        align.show()
 
-        align = gtk.Alignment(1.0, 0.5)
+        row += 1
         label = gtk.Label()
+        label.set_alignment(1.0, 0.5)
         label.set_markup("<b>Timestamp:</b>")
-        align.add(label)
-        self.table.attach(align, 0, 1, 4, 5, gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         label.show()
 
-        align = gtk.Alignment(0.0, 0.5)
         self.timestamp = gtk.Label()
+        self.timestamp.set_ellipsize(pango.ELLIPSIZE_END)
+        self.timestamp.set_alignment(0.0, 0.5)
         self.timestamp.set_selectable(True)
-        align.add(self.timestamp)
-        self.table.attach(align, 1, 2, 4, 5, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(self.timestamp, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
         self.timestamp.show()
 
-        align = gtk.Alignment(1.0, 0.5)
+        row += 1
         self.tags_label = gtk.Label()
+        self.tags_label.set_alignment(1.0, 0.5)
         self.tags_label.set_markup("<b>Tags:</b>")
-        align.add(self.tags_label)
-        align.show()
-        self.table.attach(align, 0, 1, 5, 6, gtk.FILL, gtk.FILL)
+        self.table.attach(self.tags_label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         self.tags_label.show()
 
-        align = gtk.Alignment(0.0, 0.5)
         self.tags_list = gtk.Label()
-        align.add(self.tags_list)
-        self.table.attach(align, 1, 2, 5, 6, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        align.show()
+        self.tags_list.set_ellipsize(pango.ELLIPSIZE_MIDDLE)
+        self.tags_list.set_alignment(0.0, 0.5)
+        self.table.attach(self.tags_list, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
         self.tags_list.show()
 
         self.connect('notify::revision', self._add_tags)

=== modified file 'seahorse.py'
--- seahorse.py	2008-06-20 03:33:17 +0000
+++ seahorse.py	2008-06-29 19:07:23 +0000
@@ -85,7 +85,10 @@
         if key not in keyset:
             keyset[key] = Key(key)
 
-        return keyset[key]
+        return (cleartext, keyset[key])
+
+    return (cleartext, None)
+
 
 class Key:
 

=== added file 'search.py'
--- search.py	1970-01-01 00:00:00 +0000
+++ search.py	2008-07-20 13:23:29 +0000
@@ -0,0 +1,96 @@
+# Copyright (C) 2008 by Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+
+import gobject
+import gtk
+
+from bzrlib.plugins.search import index as _mod_index
+from bzrlib.plugins.gtk import _i18n
+
+class SearchDialog(gtk.Dialog):
+    """Search dialog."""
+    def __init__(self, index, parent=None):
+        gtk.Dialog.__init__(self, title="Search Revisions",
+                                  parent=parent,
+                                  flags=gtk.DIALOG_MODAL,
+                                  buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK,
+                                           gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+        pixbuf = self.render_icon(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
+        self.set_icon(pixbuf)
+        
+        # Get arguments
+        self.index = index
+
+        self.searchbar = gtk.HBox()
+        searchbar_label = gtk.Label(_i18n("Search for:"))
+        self.searchbar.pack_start(searchbar_label, False, False, 0)
+        self.searchentry = gtk.Entry()
+        self.searchentry.connect('activate', self._searchentry_activate)
+        # TODO: Completion using the bzr-search suggests functionality
+        self.searchbar.add(self.searchentry)
+        self.vbox.pack_start(self.searchbar, expand=False, fill=False)
+
+        self.results_model = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
+        self.results_treeview = gtk.TreeView(self.results_model)
+        self.results_treeview.connect("row-activated", self._searchresult_row_activated)
+
+        documentname_column = gtk.TreeViewColumn(_i18n("Document"), gtk.CellRendererText(), text=0)
+        self.results_treeview.append_column(documentname_column)
+
+        summary_column = gtk.TreeViewColumn(_i18n("Summary"), gtk.CellRendererText(), text=1)
+        self.results_treeview.append_column(summary_column)
+
+        results_scrolledwindow = gtk.ScrolledWindow()
+        results_scrolledwindow.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
+        results_scrolledwindow.add(self.results_treeview)
+
+        self.vbox.pack_start(results_scrolledwindow, expand=True, fill=True)
+
+        self.set_default_size(600, 400)
+        # Show the dialog
+        self.show_all()
+
+    def get_revision(self):
+        (path, focus) = self.results_treeview.get_cursor()
+        if path is None:
+            return None
+        iter = self.results_model.get_iter(path)
+        return self.results_model.get_value(iter, 2)
+
+    def _searchentry_activate(self, entry):
+        self.results_model.clear()
+        self.index._branch.lock_read()
+        try:
+            query = [(query_item,) for query_item in self.searchentry.get_text().split(" ")]
+            for result in self.index.search(query):
+                if isinstance(result, _mod_index.FileTextHit):
+                    revid = result.text_key[-1]
+                elif isinstance(result, _mod_index.RevisionHit):
+                    revid = result.revision_key[0]
+                else:
+                    raise AssertionError()
+                self.results_model.append([result.document_name(), result.summary(), revid])
+        finally:
+            self.index._branch.unlock()
+    
+    def _searchresult_row_activated(self, treeview, path, view_column):
+        self.response(gtk.RESPONSE_OK)

=== modified file 'setup.py'
--- setup.py	2008-06-27 16:53:56 +0000
+++ setup.py	2008-07-24 11:28:39 +0000
@@ -79,7 +79,7 @@
         files = []
         if sys.platform[:5] == 'linux':
             cmd = os.popen('pkg-config --variable=pythondir nautilus-python', 'r')
-            res = cmd.readline()
+            res = cmd.readline().strip()
             ret = cmd.close()
             
             if ret is None:
@@ -96,7 +96,7 @@
     maintainer_email = "jelmer@samba.org",
     description = "GTK+ Frontends for various Bazaar commands",
     license = "GNU GPL v2 or later",
-    scripts=['olive-gtk', 'bzr-handle-patch'],
+    scripts=['olive-gtk', 'bzr-handle-patch', 'bzr-notify'],
     package_dir = {
         "bzrlib.plugins.gtk": ".",
         "bzrlib.plugins.gtk.viz": "viz", 
@@ -115,10 +115,9 @@
         "bzrlib.plugins.gtk.branchview",
         "bzrlib.plugins.gtk.preferences",
         ],
-    data_files=[('share/olive', ['olive.glade',
-                                 'cmenu.ui',
+    data_files=[('share/olive', ['cmenu.ui',
                                 ]),
-                ('share/olive/icons', ['icons/commit.png',
+                ('share/bzr-gtk/icons', ['icons/commit.png',
                                  'icons/commit16.png',
                                  'icons/diff.png',
                                  'icons/diff16.png',
@@ -129,11 +128,13 @@
                                  'icons/push.png',
                                  'icons/push16.png',
                                  'icons/refresh.png',
-                                 'icons/oliveicon2.png']),
-                ('share/bzr-gtk/icons', ['icons/sign-bad.png',
+                                 'icons/olive-gtk.png',
+                                 'icons/oliveicon2.png',
+                                 'icons/sign-bad.png',
                                  'icons/sign-ok.png',
                                  'icons/sign.png',
                                  'icons/sign-unknown.png',
+                                 'icons/tag-16.png',
                                  'icons/bug.png',
                                  'icons/bzr-icon-64.png']),
                 ('share/applications', ['olive-gtk.desktop',

=== modified file 'status.py'
--- status.py	2008-05-05 18:16:46 +0000
+++ status.py	2008-07-08 21:40:38 +0000
@@ -28,12 +28,13 @@
     """ Display Status window and perform the needed actions. """
     def __init__(self, wt, wtpath, revision=None):
         """ Initialize the Status window. """
-        super(StatusDialog, self).__init__(flags=gtk.DIALOG_MODAL, buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
+        super(StatusDialog, self).__init__(flags=gtk.DIALOG_MODAL, buttons=(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE))
         self.set_title("Working tree changes")
+        self.set_default_response(gtk.RESPONSE_CLOSE)
         self._create()
         self.wt = wt
         self.wtpath = wtpath
-        
+
         if revision is None:
             revision = self.wt.branch.last_revision()
             
@@ -44,13 +45,22 @@
 
     def _create(self):
         self.set_default_size(400, 300)
-        scrolledwindow = gtk.ScrolledWindow()
-        scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        self.set_has_separator(False)
+        sw = gtk.ScrolledWindow()
+        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        sw.set_shadow_type(gtk.SHADOW_IN)
         self.treeview = gtk.TreeView()
-        scrolledwindow.add(self.treeview)
-        self.vbox.pack_start(scrolledwindow, True, True)
+        sw.add(self.treeview)
+        self.vbox.pack_start(sw, True, True)
         self.vbox.show_all()
 
+        # sane border and spacing widths (as recommended by GNOME HIG) 
+        self.set_border_width(5)
+        sw.set_border_width(5)
+        self.vbox.set_spacing(2)
+        self.action_area.set_border_width(5)
+
+
     def row_diff(self, tv, path, tvc):
         file = self.model[path][1]
         if file is None:
@@ -61,6 +71,7 @@
         window.set_file(file)
         window.show()
 
+
     def _generate_status(self):
         """ Generate 'bzr status' output. """
         self.model = gtk.TreeStore(str, str)

=== modified file 'tests/__init__.py'
--- tests/__init__.py	2008-06-29 15:54:40 +0000
+++ tests/__init__.py	2008-06-29 22:44:42 +0000
@@ -32,9 +32,6 @@
         'test_history',
         ]
 
-    if os.name == 'nt':
-        testmod_names.append("test_tortoise_bzr")
-
     result.addTest(loader.loadTestsFromModuleNames(["%s.%s" % (__name__, i) for i in testmod_names]))
     return result
 

=== removed file 'tests/test_tortoise_bzr.py'
--- tests/test_tortoise_bzr.py	2007-03-15 12:43:48 +0000
+++ tests/test_tortoise_bzr.py	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-# Copyright (C) 2007 Jelmer Vernooij <jelmer@samba.org>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib import config
-
-import win32com.client as client
-
-class TestsShellExtension(TestCaseInTempDir):
-    def setUp(self):
-        super(TestsUrlHistory, self).setUp()
-        self.ext = client.Dispatch("Bazaar.ShellExtension.ContextMenu")
-
-    def test_get_command_string(self):
-        self.assertEqual(u"Hello from Python!!", self.ext.GetCommandString(1,1))

=== modified file 'ui.py'
--- ui.py	2008-06-29 16:11:12 +0000
+++ ui.py	2008-07-17 12:46:31 +0000
@@ -22,7 +22,7 @@
 import gtk
 import sys
 
-import bzrlib.progress
+from bzrlib import progress
 from bzrlib.ui import UIFactory
 
 
@@ -40,60 +40,118 @@
                          gtk.RESPONSE_NO)
 
 
-class GtkProgressBar(gtk.ProgressBar):
-    def __init__(self, stack):
-        super(GtkProgressBar, self).__init__()
+class GtkProgressBar(gtk.ProgressBar,progress._BaseProgressBar):
+    def __init__(self, _stack=None):
+        gtk.ProgressBar.__init__(self)
         self.set_fraction(0.0)
-        self._stack = stack
+        progress._BaseProgressBar.__init__(self, _stack=_stack)
         self.current = None
         self.total = None
 
-    def finished(self):
-        self._stack.remove(self)
-
     def clear(self):
-        pass
+        self.hide()
 
     def tick(self):
         self.pulse()
 
-    def update(self, msg=None, current=None, total=None):
-        if current:
-            self.current = current
-        if total:
-            self.total = total
+    def child_update(self, message, current, total):
+        pass
+
+    def update(self, msg=None, current_cnt=None, total_cnt=None):
+        if current_cnt is not None:
+            self.current = current_cnt
+        if total_cnt is not None:
+            self.total = total_cnt
         if msg is not None:
             self.set_text(msg)
         if None not in (self.current, self.total):
-            self.set_fraction(1.0 * self.current / self.total)
+            self.fraction = float(self.current) / self.total
+            if self.fraction < 0.0 or self.fraction > 1.0:
+                raise AssertionError
+            self.set_fraction(self.fraction)
         while gtk.events_pending():
             gtk.main_iteration()
 
 
-class GtkProgressBarStack(gtk.Window):
-    def __init__(self):
-        super(GtkProgressBarStack, self).__init__(type=gtk.WINDOW_TOPLEVEL)
+class ProgressBarWindow(gtk.Window):
+    def __init__(self, to_file=None, show_pct=None, show_spinner=None, show_eta=None, 
+                 show_bar=None, show_count=None, to_messages_file=None, _stack=None):
+        super(ProgressBarWindow, self).__init__(type=gtk.WINDOW_TOPLEVEL)
+        self._stack = _stack
         self.set_border_width(0)
         self.set_title("Progress")
         self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
-        self.vbox = gtk.VBox()
-        self.add(self.vbox)
+        self.pb = GtkProgressBar(self)
+        self.add(self.pb)
+        self.resize(250, 15)
         self.set_resizable(False)
-
-    def _adapt_size(self):
-        self.resize(250, 15 * len(self.vbox.get_children()))
-
-    def get_nested(self):
-        nested = GtkProgressBar(self)
-        self.vbox.pack_start(nested)
-        self._adapt_size()
-        self.show_all()
-        return nested
-
-    def remove(self, pb):
-        self.vbox.remove(pb)
-        if len(self.vbox.get_children()) == 0: # If there is nothing to show, don't leave a ghost window here
-             self.destroy()
+        self.show_all()
+
+    def return_pb(self, pb):
+        self._stack.return_pb(self)
+    
+    def update(self, *args, **kwargs):
+        self.pb.update(*args, **kwargs)
+
+    def finished(self):
+        self.pb.finished()
+        self.hide_all()
+ 
+    def clear(self):
+        self.pb.clear()
+        self.destroy()
+
+    def child_progress(self, *args, **kwargs):
+        return self.pb.child_progress(*args, **kwargs)
+
+    def child_update(self, *args, **kwargs):
+        return self.pb.child_update(*args, **kwargs)
+
+    def get_progress_bar(self):
+        self.show_all()
+        return self
+
+
+class ProgressPanel(gtk.HBox):
+    def __init__(self):
+        super(ProgressPanel, self).__init__()
+        image_loading = gtk.image_new_from_stock(gtk.STOCK_REFRESH,
+                                                 gtk.ICON_SIZE_BUTTON)
+        image_loading.show()
+        
+        self.pb = GtkProgressBar(self)
+        self.set_spacing(5)
+        self.set_border_width(5)        
+        self.pack_start(image_loading, False, False)
+        self.pack_start(self.pb, True, True)
+
+    def return_pb(self, pb):
+        self._stack.return_pb(self)
+
+    def get_progress_bar(self, to_file=None, show_pct=None, show_spinner=None, show_eta=None, 
+                         show_bar=None, show_count=None, to_messages_file=None, 
+                         _stack=None):
+        self._stack = _stack
+        self.show_all()
+        return self
+    
+    def update(self, *args, **kwargs):
+        self.pb.update(*args, **kwargs)
+
+    def finished(self):
+        self.pb.finished()
+        self.hide_all()
+
+    def clear(self):
+        self.pb.clear()
+        self.hide_all()
+
+    def child_progress(self, *args, **kwargs):
+        return self.pb.child_progress(*args, **kwargs)
+
+    def child_update(self, *args, **kwargs):
+        return self.pb.child_update(*args, **kwargs)
+
 
 
 class PasswordDialog(gtk.Dialog):
@@ -128,7 +186,7 @@
 
         """
         super(GtkUIFactory, self).__init__()
-        self._progress_bar_stack = None
+        self.set_nested_progress_bar_widget(ProgressBarWindow)
 
     def get_boolean(self, prompt):
         """GtkDialog with yes/no answers"""
@@ -156,11 +214,12 @@
         else:
             return None
 
+    def set_nested_progress_bar_widget(self, widget):
+        self._progress_bar_stack = progress.ProgressBarStack(klass=widget)
+
     def nested_progress_bar(self):
         """Return a nested progress bar.
         """
-        if self._progress_bar_stack is None:
-            self._progress_bar_stack = GtkProgressBarStack()
         return self._progress_bar_stack.get_nested()
 
     def set_progress_bar_vbox(self, vbox):

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2008-06-06 17:46:26 +0000
+++ viz/branchwin.py	2008-07-25 13:32:06 +0000
@@ -13,14 +13,16 @@
 import gobject
 import pango
 
-from bzrlib.plugins.gtk.window import Window
 from bzrlib.plugins.gtk import icon_path
+from bzrlib.plugins.gtk.branchview import TreeView, treemodel
 from bzrlib.plugins.gtk.tags import AddTagDialog
 from bzrlib.plugins.gtk.preferences import PreferencesWindow
-from bzrlib.plugins.gtk.branchview import TreeView, treemodel
+from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
+from bzrlib.plugins.gtk.window import Window
+
+from bzrlib.config import BranchConfig, GlobalConfig
 from bzrlib.revision import Revision, NULL_REVISION
-from bzrlib.config import BranchConfig
-from bzrlib.config import GlobalConfig
+from bzrlib.trace import mutter
 
 class BranchWindow(Window):
     """Branch window.
@@ -46,6 +48,8 @@
         self.maxnum      = maxnum
         self.config      = GlobalConfig()
 
+        self._sizes      = {} # window and widget sizes
+
         if self.config.get_user_option('viz-compact-view') == 'yes':
             self.compact_view = True
         else:
@@ -53,12 +57,19 @@
 
         self.set_title(branch.nick + " - revision history")
 
-        # Use three-quarters of the screen by default
-        screen = self.get_screen()
-        monitor = screen.get_monitor_geometry(0)
-        width = int(monitor.width * 0.75)
-        height = int(monitor.height * 0.75)
+        # user-configured window size
+        size = self._load_size('viz-window-size')
+        if size:
+            width, height = size
+        else:
+            # Use three-quarters of the screen by default
+            screen = self.get_screen()
+            monitor = screen.get_monitor_geometry(0)
+            width = int(monitor.width * 0.75)
+            height = int(monitor.height * 0.75)
         self.set_default_size(width, height)
+        self.set_size_request(width/3, height/3)
+        self.connect("size-allocate", self._on_size_allocate, 'viz-window-size')
 
         # FIXME AndyFitz!
         icon = self.render_icon(gtk.STOCK_INDEX, gtk.ICON_SIZE_BUTTON)
@@ -102,18 +113,20 @@
         self.add(vbox)
 
         self.paned = gtk.VPaned()
-        self.paned.pack1(self.construct_top(), resize=True, shrink=False)
-        self.paned.pack2(self.construct_bottom(), resize=False, shrink=True)
+        self.paned.pack1(self.construct_top(), resize=False, shrink=True)
+        self.paned.pack2(self.construct_bottom(), resize=True, shrink=False)
         self.paned.show()
 
-        vbox.pack_start(self.construct_menubar(), expand=False, fill=True)
-        vbox.pack_start(self.construct_navigation(), expand=False, fill=True)
-        
+        nav = self.construct_navigation()
+        menubar = self.construct_menubar()
+        vbox.pack_start(menubar, expand=False, fill=True)
+        vbox.pack_start(nav, expand=False, fill=True)
+
         vbox.pack_start(self.paned, expand=True, fill=True)
         vbox.set_focus_child(self.paned)
 
         vbox.show()
-
+    
     def construct_menubar(self):
         menubar = gtk.MenuBar()
 
@@ -135,15 +148,12 @@
         edit_menuitem = gtk.MenuItem("_Edit")
         edit_menuitem.set_submenu(edit_menu)
 
-        edit_menu_find = gtk.ImageMenuItem(gtk.STOCK_FIND)
-
         edit_menu_branchopts = gtk.MenuItem("Branch Settings")
         edit_menu_branchopts.connect('activate', lambda x: PreferencesWindow(self.branch.get_config()).show())
 
         edit_menu_globopts = gtk.MenuItem("Global Settings")
         edit_menu_globopts.connect('activate', lambda x: PreferencesWindow().show())
 
-        edit_menu.add(edit_menu_find)
         edit_menu.add(edit_menu_branchopts)
         edit_menu.add(edit_menu_globopts)
 
@@ -159,15 +169,40 @@
 
         view_menu_toolbar = gtk.CheckMenuItem("Show Toolbar")
         view_menu_toolbar.set_active(True)
+        if self.config.get_user_option('viz-toolbar-visible') == 'False':
+            view_menu_toolbar.set_active(False)
+            self.toolbar.hide()
         view_menu_toolbar.connect('toggled', self._toolbar_visibility_changed)
 
         view_menu_compact = gtk.CheckMenuItem("Show Compact Graph")
         view_menu_compact.set_active(self.compact_view)
         view_menu_compact.connect('activate', self._brokenlines_toggled_cb)
-
+        
+        view_menu_diffs = gtk.CheckMenuItem("Show Diffs")
+        view_menu_diffs.set_active(False)
+        if self.config.get_user_option('viz-show-diffs') == 'True':
+            view_menu_diffs.set_active(True)
+        view_menu_diffs.connect('toggled', self._diff_visibility_changed)
+        
+        view_menu_wide_diffs = gtk.CheckMenuItem("Wide Diffs")
+        view_menu_wide_diffs.set_active(False)
+        if self.config.get_user_option('viz-wide-diffs') == 'True':
+            view_menu_wide_diffs.set_active(True)
+        view_menu_wide_diffs.connect('toggled', self._diff_placement_changed)
+        
+        view_menu_wrap_diffs = gtk.CheckMenuItem("Wrap _Long Lines in Diffs")
+        view_menu_wrap_diffs.set_active(False)
+        if self.config.get_user_option('viz-wrap-diffs') == 'True':
+            view_menu_wrap_diffs.set_active(True)
+        view_menu_wrap_diffs.connect('toggled', self._diff_wrap_changed)
+                
         view_menu.add(view_menu_toolbar)
         view_menu.add(view_menu_compact)
         view_menu.add(gtk.SeparatorMenuItem())
+        view_menu.add(view_menu_diffs)
+        view_menu.add(view_menu_wide_diffs)
+        view_menu.add(view_menu_wrap_diffs)
+        view_menu.add(gtk.SeparatorMenuItem())
 
         self.mnu_show_revno_column = gtk.CheckMenuItem("Show Revision _Number Column")
         self.mnu_show_date_column = gtk.CheckMenuItem("Show _Date Column")
@@ -202,24 +237,9 @@
         go_menu.add(gtk.SeparatorMenuItem())
         go_menu.add(self.go_menu_tags)
 
-        revision_menu = gtk.Menu()
+        self.revision_menu = RevisionMenu(self.branch.repository, [], self.branch, parent=self)
         revision_menuitem = gtk.MenuItem("_Revision")
-        revision_menuitem.set_submenu(revision_menu)
-
-        revision_menu_diff = gtk.MenuItem("View Changes")
-        revision_menu_diff.connect('activate', 
-                self._menu_diff_cb)
-        
-        revision_menu_compare = gtk.MenuItem("Compare with...")
-        revision_menu_compare.connect('activate',
-                self._compare_with_cb)
-
-        revision_menu_tag = gtk.MenuItem("Tag Revision")
-        revision_menu_tag.connect('activate', self._tag_revision_cb)
-
-        revision_menu.add(revision_menu_tag)
-        revision_menu.add(revision_menu_diff)
-        revision_menu.add(revision_menu_compare)
+        revision_menuitem.set_submenu(self.revision_menu)
 
         branch_menu = gtk.Menu()
         branch_menuitem = gtk.MenuItem("_Branch")
@@ -228,6 +248,21 @@
         branch_menu.add(gtk.MenuItem("Pu_ll Revisions"))
         branch_menu.add(gtk.MenuItem("Pu_sh Revisions"))
 
+        try:
+            from bzrlib.plugins import search
+        except ImportError:
+            mutter("Didn't find search plugin")
+        else:
+            branch_menu.add(gtk.SeparatorMenuItem())
+
+            branch_index_menuitem = gtk.MenuItem("_Index")
+            branch_index_menuitem.connect('activate', self._branch_index_cb)
+            branch_menu.add(branch_index_menuitem)
+
+            branch_search_menuitem = gtk.MenuItem("_Search")
+            branch_search_menuitem.connect('activate', self._branch_search_cb)
+            branch_menu.add(branch_search_menuitem)
+
         help_menu = gtk.Menu()
         help_menuitem = gtk.MenuItem("_Help")
         help_menuitem.set_submenu(help_menu)
@@ -273,6 +308,15 @@
         align = gtk.Alignment(0.0, 0.0, 1.0, 1.0)
         align.set_padding(5, 0, 0, 0)
         align.add(self.treeview)
+        # user-configured size
+        size = self._load_size('viz-graph-size')
+        if size:
+            width, height = size
+            align.set_size_request(width, height)
+        else:
+            (width, height) = self.get_size()
+            align.set_size_request(width, int(height / 2.5))
+        align.connect('size-allocate', self._on_size_allocate, 'viz-graph-size')
         align.show()
 
         return align
@@ -300,15 +344,37 @@
 
     def construct_bottom(self):
         """Construct the bottom half of the window."""
+        if self.config.get_user_option('viz-wide-diffs') == 'True':
+            self.diff_paned = gtk.VPaned()
+        else:
+            self.diff_paned = gtk.HPaned()
+        (width, height) = self.get_size()
+        self.diff_paned.set_size_request(20, 20) # shrinkable
+
         from bzrlib.plugins.gtk.revisionview import RevisionView
         self.revisionview = RevisionView(branch=self.branch)
-        (width, height) = self.get_size()
-        self.revisionview.set_size_request(width, int(height / 2.5))
+        self.revisionview.set_size_request(width/3, int(height / 2.5))
+        # user-configured size
+        size = self._load_size('viz-revisionview-size')
+        if size:
+            width, height = size
+            self.revisionview.set_size_request(width, height)
+        self.revisionview.connect('size-allocate', self._on_size_allocate, 'viz-revisionview-size')
         self.revisionview.show()
         self.revisionview.set_show_callback(self._show_clicked_cb)
         self.revisionview.connect('notify::revision', self._go_clicked_cb)
         self.treeview.connect('tag-added', lambda w, t, r: self.revisionview.update_tags())
-        return self.revisionview
+        self.diff_paned.pack1(self.revisionview)
+
+        from bzrlib.plugins.gtk.diff import DiffWidget
+        self.diff = DiffWidget()
+        self.diff_paned.pack2(self.diff)
+
+        self.diff_paned.show_all()
+        if self.config.get_user_option('viz-show-diffs') != 'True':
+            self.diff.hide()
+
+        return self.diff_paned
 
     def _tag_selected_cb(self, menuitem, revid):
         self.treeview.set_revision_id(revid)
@@ -319,6 +385,8 @@
         parents  = self.treeview.get_parents()
         children = self.treeview.get_children()
 
+        self.revision_menu.set_revision_ids([revision.revision_id])
+
         if revision and revision != NULL_REVISION:
             prev_menu = gtk.Menu()
             if len(parents) > 0:
@@ -363,7 +431,8 @@
 
             self.revisionview.set_revision(revision)
             self.revisionview.set_children(children)
-    
+            self.update_diff_panel(revision, parents)
+
     def _tree_revision_activated(self, widget, path, col):
         # TODO: more than one parent
         """Callback for when a treeview row gets activated."""
@@ -378,19 +447,6 @@
         self.show_diff(revision.revision_id, parent_id)
         self.treeview.grab_focus()
         
-    def _menu_diff_cb(self,w):
-        (path, focus) = self.treeview.treeview.get_cursor()
-        revid = self.treeview.model[path][treemodel.REVID]
-        
-        parentids = self.branch.repository.revision_parents(revid)
-
-        if len(parentids) == 0:
-            parentid = NULL_REVISION
-        else:
-            parentid = parentids[0]
-        
-        self.show_diff(revid,parentid)    
-
     def _back_clicked_cb(self, *args):
         """Callback for when the back button is clicked."""
         self.treeview.back()
@@ -409,22 +465,6 @@
         self.show_diff(revid, parentid)
         self.treeview.grab_focus()
 
-    def _compare_with_cb(self,w):
-        """Callback for revision 'compare with' menu. Will show a small
-            dialog with branch revisions to compare with selected revision in TreeView"""
-        
-        from bzrlib.plugins.gtk.revbrowser import RevisionBrowser
-        
-        rb = RevisionBrowser(self.branch,self)
-        ret = rb.run()
-        
-        if ret == gtk.RESPONSE_OK:          
-            (path, focus) = self.treeview.treeview.get_cursor()
-            revid = self.treeview.model[path][treemodel.REVID]
-            self.show_diff(revid, rb.selected_revid)
-            
-        rb.destroy()
-            
     def _set_revision_cb(self, w, revision_id):
         self.treeview.set_revision_id(revision_id)
 
@@ -440,21 +480,35 @@
         self.treeview.set_property('compact', self.compact_view)
         self.treeview.refresh()
 
-    def _tag_revision_cb(self, w):
+    def _branch_index_cb(self, w):
+        from bzrlib.plugins.search import index as _mod_index
+        _mod_index.index_url(self.branch.base)
+
+    def _branch_search_cb(self, w):
+        from bzrlib.plugins.search import index as _mod_index
+        from bzrlib.plugins.gtk.search import SearchDialog
+        from bzrlib.plugins.search import errors as search_errors
+
         try:
-            self.treeview.set_sensitive(False)
-            dialog = AddTagDialog(self.branch.repository, self.treeview.get_revision().revision_id, self.branch)
-            response = dialog.run()
-            if response != gtk.RESPONSE_NONE:
-                dialog.hide()
-            
-                if response == gtk.RESPONSE_OK:
-                    self.treeview.add_tag(dialog.tagname, dialog._revid)
-                
-                dialog.destroy()
-
-        finally:
-            self.treeview.set_sensitive(True)
+            index = _mod_index.open_index_url(self.branch.base)
+        except search_errors.NoSearchIndex:
+            dialog = gtk.MessageDialog(self, type=gtk.MESSAGE_QUESTION, 
+                buttons=gtk.BUTTONS_OK_CANCEL, 
+                message_format="This branch has not been indexed yet. "
+                               "Index now?")
+            if dialog.run() == gtk.RESPONSE_OK:
+                dialog.destroy()
+                index = _mod_index.index_url(self.branch.base)
+            else:
+                dialog.destroy()
+                return
+
+        dialog = SearchDialog(index)
+        
+        if dialog.run() == gtk.RESPONSE_OK:
+            self.set_revision(dialog.get_revision())
+
+        dialog.destroy()
 
     def _about_dialog_cb(self, w):
         from bzrlib.plugins.gtk.about import AboutDialog
@@ -467,10 +521,44 @@
 
     def _toolbar_visibility_changed(self, col):
         if col.get_active():
-            self.toolbar.show() 
+            self.toolbar.show()
         else:
             self.toolbar.hide()
-
+        self.config.set_user_option('viz-toolbar-visible', col.get_active())
+
+    def _make_diff_nonzero_size(self):
+        """make sure the diff isn't zero-width or zero-height"""
+        alloc = self.diff.get_allocation()
+        if (alloc.width < 10) or (alloc.height < 10):
+            width, height = self.get_size()
+            self.revisionview.set_size_request(width/3, int(height / 2.5))
+
+    def _diff_visibility_changed(self, col):
+        """Hide or show the diff panel."""
+        if col.get_active():
+            self.diff.show()
+            self._make_diff_nonzero_size()
+        else:
+            self.diff.hide()
+        self.config.set_user_option('viz-show-diffs', str(col.get_active()))
+        self.update_diff_panel()
+
+    def _diff_placement_changed(self, col):
+        """Toggle the diff panel's position."""
+        self.config.set_user_option('viz-wide-diffs', str(col.get_active()))
+
+        old = self.paned.get_child2()
+        self.paned.remove(old)
+        self.paned.pack2(self.construct_bottom(), resize=True, shrink=False)
+        self._make_diff_nonzero_size()
+
+        self.treeview.emit('revision-selected')
+    
+    def _diff_wrap_changed(self, widget):
+        """Toggle word wrap in the diff widget."""
+        self.config.set_user_option('viz-wrap-diffs', widget.get_active())
+        self.diff._on_wraplines_toggled(widget)
+    
     def _show_about_cb(self, w):
         dialog = AboutDialog()
         dialog.connect('response', lambda d,r: d.destroy())
@@ -501,6 +589,34 @@
 
         self.go_menu_tags.show_all()
 
+    def _load_size(self, name):
+        """Read and parse 'name' from self.config.
+        The value is a string, formatted as WIDTHxHEIGHT
+        Returns None, or (width, height)
+        """
+        size = self.config.get_user_option(name)
+        if size:
+            width, height = [int(num) for num in size.split('x')]
+            # avoid writing config every time we start
+            self._sizes[name] = (width, height)
+            return width, height
+        return None
+
+    def _on_size_allocate(self, widget, allocation, name):
+        """When window has been resized, save the new size."""
+        width, height = 0, 0
+        if name in self._sizes:
+            width, height = self._sizes[name]
+
+        size_changed = (width != allocation.width) or \
+                (height != allocation.height)
+
+        if size_changed:
+            width, height = allocation.width, allocation.height
+            self._sizes[name] = (width, height)
+            value = '%sx%s' % (width, height)
+            self.config.set_user_option(name, value)
+
     def show_diff(self, revid=None, parentid=None):
         """Open a new window to show a diff between the given revisions."""
         from bzrlib.plugins.gtk.diff import DiffWindow
@@ -516,4 +632,27 @@
         window.set_diff(description, rev_tree, parent_tree)
         window.show()
 
-
+    def update_diff_panel(self, revision=None, parents=None):
+        """Show the current revision in the diff panel."""
+        if self.config.get_user_option('viz-show-diffs') != 'True':
+            return
+
+        if not revision: # default to selected row
+            revision = self.treeview.get_revision()
+        if (not revision) or (revision == NULL_REVISION):
+            return
+
+        if not parents: # default to selected row's parents
+            parents  = self.treeview.get_parents()
+        if len(parents) == 0:
+            parent_id = None
+        else:
+            parent_id = parents[0]
+
+        rev_tree    = self.branch.repository.revision_tree(revision.revision_id)
+        parent_tree = self.branch.repository.revision_tree(parent_id)
+
+        self.diff.set_diff(rev_tree, parent_tree)
+        if self.config.get_user_option('viz-wrap-diffs') == 'True':
+            self.diff._on_wraplines_toggled(wrap=True)
+        self.diff.show_all()

